/ WIF CARD GAME - 21
/ ALPHANUMERIC DISPLAY TO DEV0 OUT
/ KEYPAD2 TO DEV0 IN
/ THERE IS A 21 GAME TEMPLATE FOR KEYPAD2 IN THE INSTALL DIRECTORY - cards21.kpf
/
/ COMPILE AND RUN THE PROGRAM FROM START - ADDRESS 0
/ THE SOFTWARE WILL SHUFFLE A NEW DECK OF 52 CARDS AND
/ DEAL 2 CARDS FOR THE PLAYER AND 2 CARDS FOR THE BANKER
/ THE PLAYER CARDS ARE DISPLAYED ON THE BOTTOM DISPLAY ROW
/ THE PLAYER CARDS TOTAL IS ALSO DISPLAYED
/
/ CARDS 2 - 9 HAVE THAT VALUE, JACK, QUEEN AND KING HAVE 10 VALUE, ACE HAS 11 VALUE
/ THE CARD VALUES ARE STORED AS PACKED BCD VALUES IN THE STORAGE REGISTERS
/ 
/ THE BANKER WILL DEAL THE PLAYER A NEW CARD WHEN THE 'HIT' BUTTON IS PRESSED.
/ THE DISPLAY WILL SHOW THE NEW CARD AND TOTAL
/ THIS CAN CONTINUE UNTIL THE PLAYER 'BUSTS' THE 21 SCORE
/ THE PLAYER CAN ALSO DECIDE TO SIT, BY PRESSING THE 'SIT' BUTTON
/
/ ONCE THE PLAYER DECIDES TO SIT, THE BANKER SCREEN WILL BE DISPLAYED
/ THE BANKER WILL DEAL A NEW CARD UNTIL THE BANKER SCORE EITHER MATCHES OR BEATS THE
/ PLAYER SCORE, OR THE BANKER BUSTS 21. iN WHICH CASE THE PLAYER WINS.
/
/ THE BANKER AND PLAYER SCORE WILL THEN BE SHOWN ON THE SCREEN
/ PRESS THE HIT OR SIT KEYS TO CONTINUE PLAYING
/ PRESS 'NEW' TO START A TOTALLY NEW GAME
/
/ IF ALL 52 CARDS HAVE BEEN DEALT, A NEW DECK WILL BE SHUFFLED AND PLAY WILL CONTINUE
/ 'NEW' CAN BE PRESSED WHILE PLAYING TO START A NEW GAME
/

	_RAM

Indirect		/ reserved for Indr
CardDeck	:#D7	/ 56 bits for 52 cards
Card
Count
bankTot
playTot
bankIdx
playIdx
bankScr
playScr
cardIdx
TempA
TempB
bankCards :#D8	/ max cards a player can have is 7 before a bust
playCards :#D8	/ Eg. 2 2 2 2 3 3 3 (+ 8th) 3 = bust

	_ENDRAM

_CONST   DeckEnd CardDeck + #D6
_CONST   Player  0
_CONST   maxPcards playCards + #D8
_CONST   maxDcards bankCards + #D8
_CONST   cardSize   8	/ 8 cards pre player
_CONST   defTimer   #D200          / default timer delay = 2 seconds

start,	gosub deckDisp
	gosub clrDeck
	clrr Card	/ card value ACE to KING
	movva #B10000000
	movr a cardIdx
	clrr bankScr
	clrr playScr
	timer defTimer	/ set timer default delay
	gosub DispINI
contPlay,	gosub clrDtal
	gosub clrPtal
	clrr bankTot
	clrr playTot
	movva bankCards
	movr a bankIdx
	movva PlayCards
	movr a PlayIdx
	gosub DealPlay	/ deal 2 cards for player
	gosub DealPlay
	gosub DealBank	/ deal 2 cards for banker
	gosub DealBank
	gosub DispON
	gosub PLtotal
	reseti 0	/ reset key flag in case pressed while init'ing

	movr playTot a	/ might have busted if 2 aces dealt
	skipifa < #$22	/ value in BCD format
	goto playbust

keywt,	skipif 0	/ wait for key press
	goto keywt

	readid 0 a	/ key press into AC
	movr a TempA
	xorva 1
	stskip z clr
	goto buttNEW

	movr TempA a
	xorva 2
	stskip z clr
	goto buttHIT

	movr TempA a
	xorva 3
	stskip z clr
	goto buttSIT

	reseti 0	/ reset key flag
	goto keywt	/ invalid key

/ ---------------------------------
buttNEW,	goto start

/ ---------------------------------
buttHIT,	reseti 0	/ reset key flag
	gosub dealPlay
	gosub PLtotal
	movr playTot a	/ if player score > 21 then banker wins
	skipifa >= #$22	/ value in BCD format
	goto keywt

playbust,	timer defTimer
dlwinlp1,	timer skipof
	goto dlwinlp1

dealwin,	movva AL_YEL
	WRITOD DEV0 A
	gosub bankDisp
	gosub wins
	gosub dispFlash

	movr bankScr a	/ max score is 99
	xorva #$99
	stskip z clr
	goto doScrs

	movva 1	/ incrment banker score
	addr a bankScr t
	goto doScrs

/ ---------------------------------
buttSIT,	reseti 0	/ reset key flag
	gosub BKtotal	/ display banker cards

dealLoop,	timer defTimer	/ wait between banker plays
plwinlp1,	timer skipof
	goto plwinlp1

	movr bankTot a	/ if banker score > 21 then player wins
	skipifa < #$22	/ value in BCD format
	goto dealBust

	movr playTot a
	subr a bankTot s
	stskip c clr
	goto dealwin	/ banker has >= player score

	gosub dealBank
	gosub BKtotal
	timer #D100	/ extra wait between banker plays
plwinlp2,	timer skipof
	goto plwinlp2
	goto dealLoop

dealBust,	timer deftimer
plwinlp3,	timer skipof
	goto plwinlp3

	movva AL_YEL
	WRITOD DEV0 A
	gosub playDisp
	gosub wins
	gosub dispFlash

	movr playScr a	/ max score is 99
	xorva #$99
	stskip z clr
	goto doScrs

	movva 1	/ incrment player score
	addr a playScr t
doScrs,	gosub Scores

keywtD,	skipif 0	/ wait for key press
	goto keywtD

	readid 0 a	/ key press into AC
	xorva 1
	stskip z clr
	goto start
	goto contPlay
/
/ ----------------------
/ SUBROUTINE: CLEAR DECK
/ ----------------------
/
clrDeck,	movva 6
	movr a TempA	/ start of card deck
	movva CardDeck
	movr a Indr
	movva #$FF
newLoop,	movr a i
	incr Indr
	decrsz TempA
	goto newLoop

	movva #B11110000	/ last byte has cards 53 - 56 clear
	movr a i
	return
/
/ --------------------------------
/ SUBROUTINE: DEAL CARD FOR banker
/ --------------------------------
/
DealBank,	movr bankIdx a	/ max cards dealt?
	xorva maxDcards
	stskip z clr
	return

	gosub emptyDeck	/ if empty deck, create a new one
	gosub getCard
	movr a TempA
	addr a bankTot s	/ add to banker total
	daac
	movr a bankTot
	movr bankIdx a
	movr a Indr
	movr Card a
	movr a i	/ add card to banker stack
	incr bankIdx
	return
/
/ --------------------------------
/ SUBROUTINE: DEAL CARD FOR PLAYER
/ --------------------------------
/
DealPlay,	movr PlayIdx a	/ max cards dealt?
	xorva maxPcards
	stskip z clr
	return

	gosub emptyDeck	/ if empty deck, create a new one
	gosub getCard
	addr a playTot s	/ add to player total
	daac
	movr a playTot
	movr playIdx a
	movr a Indr
	movr Card a
	movr a i	/ add card to player stack
	incr playIdx
	return
/
/ ---------------------------
/ SUBROUTINE: TEST EMPTY DECK
/ ---------------------------
/ if empty then create a new one
/
emptyDeck,	movva 7
	movr a TempA	/ start of card deck
	movva CardDeck
	movr a Indr
zerLoop,	movr i a
	stskip z set
	return	/ non zero

	decrsz TempA
	goto zerLoop

	gosub deckDisp
	gosub clrDeck
	return
/
/ -------------------------------------------
/ SUBROUTINE: GET THE NEXT CARD FROM THE DECK
/ -------------------------------------------
/
getCard,	movva CardDeck
	movr a Indr
	randa	/ get random card
	andva #$7F
	movr a TempA
gcLoop,	movr cardIdx a	/ if card bit = 1 then valid card
	andr a i s	/ else skip to next card bit
	stskip z clr	/ valid card?
	goto shftCard	/ no

incCard,	movr TempA a	/ valid catd bit found, random count = 0?
	stskip z clr
	goto gotCard	/ yes, use this card

	decr TempA
	incr Card	/ next card, if Card = 13, then = 0
	movr Card a
	skipifa < #D13
	clrr Card

shftCard,	stflag c clr
	rotr cardIdx	/ shift to next bit
	stskip c set	/ if carry = 1 then next card byte
	goto gcLoop

	movva DeckEnd
	xorr a Indr s
	stskip z set
	goto nextReg

	movva CardDeck
	movr a Indr
	goto rstBit

nextReg,	incr Indr	/ next card array byte
rstBit,	movva #B10000000
	movr a cardIdx
	goto gcLoop

/ RETURN FROM SUBROUTINE WITH A CARD VALUE
gotCard,	movva #$FF
	xorr a cardIdx s
	andr a i t	/ mark card bit out of deck
	romptr H HIGH cardTB	/ set ROM page for [P] [TGT] instructions
	movr Card a
cardTB,	addr a p t	/ jump table
	retval #$11	/ ace (BCD 11)
	retval 1	/ 1
	retval 2	/ 2
	retval 3	/ 3
	retval 4	/ 4
	retval 5	/ 5
	retval 6	/ 6
	retval 7	/ 7
	retval 8	/ 8
	retval 9	/ 9
	retval #$10	/ jack   (BCD 10)
	retval #$10	/ queen  (BCD 10)
	retval #$10	/ king   (BCD 10)
/
/ -----------------------------------------
/ SUBROUTINE: RETURN CARD DISPLAY CHARACTER
/ -----------------------------------------
/
cardChar,	romptr H HIGH cardCH	/ set ROM page for [P] [TGT] instructions
cardCH,	addr a p t	/ jump table
	retval #"A"	/ ace
	retval #"1"	/ 1
	retval #"2"	/ 2
	retval #"3"	/ 3
	retval #"4"	/ 4
	retval #"5"	/ 5
	retval #"6"	/ 6
	retval #"7"	/ 7
	retval #"8"	/ 8
	retval #"9"	/ 9
	retval #"J"	/ jack
	retval #"Q"	/ queen
	retval #"K"	/ king
/
/ --------------------------------
/ SUBROUTINE: DISPLAY BANKER TOTAL
/ --------------------------------
/
BKtotal,	movva AL_BLU
	WRITOD DEV0 A
	gosub bankDisp
	gosub totDisp

	movva AL_BLN
	WRITOD DEV0 A
	movva AL_YEL
	WRITOD DEV0 A
 	movva #$00
	WRITOD DEV0 A

	movva bankCards
	movr a Indr
DTalLP,	movr Indr a
	xorr a bankIdx s
	stskip z clr
	goto dlTot

	movr i a
	gosub cardChar
	WRITOD DEV0 A
	incr Indr
	goto DTalLP

dlTot, 	movva #$0E	/ banker total
	WRITOD DEV0 A
	movva AL_GRN
	WRITOD DEV0 A
	movr bankTot a
	gosub out2BCD
	return
/
/ --------------------------------
/ SUBROUTINE: DISPLAY PLAYER TOTAL
/ --------------------------------
/
PLtotal,	movva AL_BLU
	WRITOD DEV0 A
	gosub playDisp
inPLtal,	gosub totDisp

	movva AL_BLN
	WRITOD DEV0 A
	movva AL_YEL
	WRITOD DEV0 A
 	movva #$00
	WRITOD DEV0 A

	movva PlayCards
	movr a Indr
PTalLP,	movr Indr a
	xorr a PlayIdx s
	stskip z clr
	goto plTot

	movr i a
	gosub cardChar
	WRITOD DEV0 A
	incr Indr
	goto PTalLP

plTot, 	movva #$0E	/ player total
	WRITOD DEV0 A
	movva AL_GRN
	WRITOD DEV0 A
	movr playTot a
	gosub out2BCD
	return
/
/ ------------------------------
/ SUBROUTINE: CLEAR banker CARDS
/ ------------------------------
/
clrDtal,	movva bankCards
	goto inclrDP
/
/ ------------------------------
/ SUBROUTINE: CLEAR PLAYER CARDS
/ ------------------------------
/
clrPtal,	movva PlayCards
inclrDP,	movr a Indr
	movva cardSize
	movr a TempA
clrDPlp,	clrr i i
	incr Indr
	decrsz TempA
	goto clrDPlp
	return
/
/ --------------------------
/ SUBROUTINE: DISPLAY SCORES
/ --------------------------
/
Scores,	movva AL_GRN
	WRITOD DEV0 A
	gosub bankDisp
	movva #$0A
	WRITOD DEV0 A
	gosub inplDisp

	movva AL_BLN
	WRITOD DEV0 A
	movva AL_BLU
	WRITOD DEV0 A

 	movva #$00	/ banker score
	WRITOD DEV0 A
	movr bankScr a
	gosub out2BCD

 	movva #$0E	/ player score
	WRITOD DEV0 A
	movr playScr a
	gosub out2BCD

	timer defTimer
scrLoop,	timer skipof
	goto scrLoop
	return
/
/ --------------------------
/ SUBROUTINE: DISPLAY "DEAL"
/ --------------------------
/
bankDisp,	gosub DispCLR
	movva AL_TLN
	WRITOD DEV0 A
	movva #"B"
	WRITOD DEV0 A
	movva #"A"
	WRITOD DEV0 A
	movva #"N"
	WRITOD DEV0 A
	movva #"K"
	WRITOD DEV0 A
	movva #"E"
	WRITOD DEV0 A
	movva #"R"
	WRITOD DEV0 A
	return
/
/ --------------------------
/ SUBROUTINE: DISPLAY "PLAY"
/ --------------------------
/
playDisp,	gosub DispCLR
	movva AL_TLN
	WRITOD DEV0 A
inplDisp,	movva #"P"
	WRITOD DEV0 A
	movva #"L"
	WRITOD DEV0 A
	movva #"A"
	WRITOD DEV0 A
	movva #"Y"
	WRITOD DEV0 A
	movva #"E"
	WRITOD DEV0 A
	movva #"R"
	WRITOD DEV0 A
	return
/
/ --------------------------
/ SUBROUTINE: DISPLAY "NEW DECK"
/ --------------------------
/
deckDisp,	movva AL_CLR	/ clear display
	WRITOD DEV0 A

	movva AL_YEL
	WRITOD DEV0 A
	movva AL_TLN
	WRITOD DEV0 A
	movva 4
	WRITOD DEV0 A
	movva #"N"
	WRITOD DEV0 A
	movva #"E"
	WRITOD DEV0 A
	movva #"W"
	WRITOD DEV0 A
	movva #" "
	WRITOD DEV0 A
	movva #"D"
	WRITOD DEV0 A
	movva #"E"
	WRITOD DEV0 A
	movva #"C"
	WRITOD DEV0 A
	movva #"K"
	WRITOD DEV0 A

	movva AL_BLN
	WRITOD DEV0 A
	movva 4
	WRITOD DEV0 A
	movva #"S"
	WRITOD DEV0 A
	movva #"H"
	WRITOD DEV0 A
	movva #"U"
	WRITOD DEV0 A
	movva #"F"
	WRITOD DEV0 A
	movva #"F"
	WRITOD DEV0 A
	movva #"L"
	WRITOD DEV0 A
	movva #"E"
	WRITOD DEV0 A
	movva #"D"
	WRITOD DEV0 A

	timer #D100
dkLoop,	timer skipof
	goto dkLoop
	return
/
/ ---------------------------
/ SUBROUTINE: DISPLAY "TOTAL"
/ ---------------------------
/
totDisp,	movva #$0B
	WRITOD DEV0 A
	movva #"T"
	WRITOD DEV0 A
	movva #"O"
	WRITOD DEV0 A
	movva #"T"
	WRITOD DEV0 A
	movva #"A"
	WRITOD DEV0 A
	movva #"L"
	WRITOD DEV0 A
	return
/
/ --------------------------
/ SUBROUTINE: DISPLAY "BUST"
/ --------------------------
/
wins,	movva #" "
	WRITOD DEV0 A
	movva #"W"
	WRITOD DEV0 A
	movva #"I"
	WRITOD DEV0 A
	movva #"N"
	WRITOD DEV0 A
	movva #"S"
	WRITOD DEV0 A
	return
/
/ --------------------------------
/ SUBROUTINE: DISPLAY 2 BCD DIGITS
/ --------------------------------
/
out2BCD,	movr a TempA
	exchr TempA a
	andva #$0F
	stskip z clr
	goto blkzero

	gosub ASCIInum
	goto outnum

blkzero,	movva #" "	/ blank leading zero
outnum,	WRITOD DEV0 A
	movr TempA a
	andva #$0F
	gosub ASCIInum
	WRITOD DEV0 A
	return
/
/ -------------------------
/ SUBROUTINE: FLASH DISPLAY
/ -------------------------
/
dispFlash,	timer #D20
	movva 5
	movr a TempB
flLoop1,	timer skipof
	goto flloop1
	gosub dispOFF

flLoop2,	timer skipof
	goto flLoop2

	gosub DispON
	decrsz TempB
	goto flLoop1

	timer #D150
flLoop3,	timer skipof
	goto flloop3
	return
/
/ ------------------------
/ SUBROUTINE: INIT DISPLAY
/ ------------------------
/
DispCLR,	movva AL_CLR
	goto DispSet/
/ ------------------------
/ SUBROUTINE: INIT DISPLAY
/ ------------------------
/
DispINI,	movva AL_INI
	goto DispSet
/
/ ---------------------------
/ SUBROUTINE: TURN DISPLAY ON
/ ---------------------------
/
DispON,	movva AL_ON
	goto DispSet
/
/ ----------------------------
/ SUBROUTINE: TURN DISPLAY OFF
/ ----------------------------
/
DispOFF,	movva AL_OFF
DispSet,	WRITOD DEV0 A
	return
/
/ ---------------------------------------
/ SUBROUTINE: CONVERT 0 - 9 TO ASCII CHAR
/ ---------------------------------------
/
ASCIInum,	addva #D48
	return
