/ WIF 32 BIT MATH ROUTINES


/	Add	REGA = REGA + REGB 
/	Subtract	REGA = REGA - REGB 
/	Multiply	REGA = REGA x REGB 
/	Divide	REGA = REGA / REGB 
/	Square Root	REGA = SQRT (REGA) 

	_RAM
Indirect	/ 0: reserved for Indr

REGA3	/ msb
REGA2
REGA1
REGA0	/ lsb

REGB3	/ msb
REGB2
REGB1
REGB0	/ lsb

REGC3	/ msb
REGC2
REGC1
REGC0	/ lsb

DSIGN	/ Digit Sign. 0 = positive, 1 = negative
DIGIT1	/ MSD
DIGIT2
DIGIT3
DIGIT4
DIGIT5	/ Decimal (BCD) digits
DIGIT6
DIGIT7
DIGIT8
DIGIT9
DIGIT10	/ LSD

MTEMP
MCOUNT
DCOUNT

	_ENDRAM


_CONST DIGIT1M1 DIGIT1 - #D1

	_ISWIMODEON


start,	movva #$12
	movr a REGA3
	movva #$22
	movr a REGA2
	movva #$64
	movr a REGA1
	movva #$12
	movr a REGA0

	movva #$00
	movr a REGB3
	movva #$00
	movr a REGB2
	movva #$56
	movr a REGB1
	movva #$64
	movr a REGB0

	gosub bin2dec

	halt
	goto start


/ ------------------------------------------
/ 32 BIT SIGNED SUTRACT
/ REGA - REGB -> REGA
/ Return carry set if overflow

subtract,	gosub negateb	/ Negate REGB
	stskip c clr
	return	/ Overflow

/ *** 32 BIT SIGNED ADD ***
/ REGA + REGB -> REGA
/ Return carry set if overflow

add,	movr REGA3 a	/ Compare signs
	xorr a REGB3 s
	movr a MTEMP
	gosub addba	/ Add REGB to REGA

	stflag c clr	/ Check signs
	movr REGB3 a	/ If signs are same
	xorr a REGA3 s	/ so must result sign
	skipbs MTEMP 7	/ else overflow
	addva #$80
	return

/ ------------------------------------------
/ 32 BIT SIGNED MULTIPLY
/ REGA x REGB -> REGA
/ Return carry set if overflow

multiply,	clrr MTEMP r	/ Reset sign flag
	gosub absa	/ Make REGA positive

	stskip c set
	gosub absb	/ Make REGB positive

	stskip c clr
	return	/ Overflow

	gosub movac	/ Move REGA to REGC
	gosub clra	/ Clear product

	movva #D31	/ Loop counter
	movr a MCOUNT

muloop,	gosub slac	/ Shift left product and multiplicand

	rotl REGC3 a	/ Test MSB of multiplicand
	stskip c clr	/ If multiplicand bit is a 1 then
	gosub addba	/ add multiplier to product

	stskip c set	/ Check for overflow
	rotl REGA3 a
	stskip c clr
	return

	decrsz MCOUNT r	/ Next
	goto muloop

	skipbc MTEMP 0	/ Check result sign
	gosub negatea	/ Negative
	return

/ ------------------------------------------
/ 32 BIT SIGNED DIVIDE
/ REGA / REGB -> REGA
/ Remainder in REGC
/ Return carry set if overflow or division by zero

divide,	clrr MTEMP r	/ Reset sign flag
	movr REGB0 a	/ Trap division by zero
	iorr a REGB1 s
	iorr a REGB2 s
	iorr a REGB3 s
	stskip z clr
	return

	gosub absa	/ Make dividend (REGA) positive

	stskip c set
	gosub absb	/ Make divisor (REGB) positive

	stskip c clr
	return	/ Overflow

	clrr REGC0 r	/ Clear remainder
	clrr REGC1 r
	clrr REGC2 r
	clrr REGC3 r
	gosub slac	/ Purge sign bit

	movva #D31	/ Loop counter
	movr a MCOUNT

dvloop,	gosub slac	/ Shift dividend (REGA) msb into remainder (REGC)

	movr REGB3 a	/ Test if remainder (REGC) >= divisor (REGB)
	subr a REGC3 s
	stskip z set
	goto dtstgt

	movr REGB2 a
	subr a REGC2 s
	stskip z set
	goto dtstgt

	movr REGB1 a
	subr a REGC1 s
	stskip z set
	goto dtstgt

	movr REGB0 a
	subr a REGC0 s
dtstgt,	stskip c set  	/ Carry set if remainder >= divisor
	goto dremlt

	movr REGB0 a 	/ Subtract divisor (REGB) from remainder (REGC)
	subr a REGC0 t
	movr REGB1 a
	stskip c set
	incrsz REGB1 a
	subr a REGC1 t
	movr REGB2 a
	stskip c set
	incrsz REGB2 a
	subr a REGC2 t
	movr REGB3 a
	stskip c set
	incrsz REGB3 a
	subr a REGC3 t
	stflag c clr
	setb REGA0 0 	/ Set quotient bit

dremlt,	decrsz MCOUNT r	/ Next
	goto dvloop

	skipbc MTEMP 0 	/ Check result sign
	gosub negatea 	/ Negative
	return

/ ------------------------------------------
/ ROUND RESULT OF DIVISION TO NEAREST INTEGER

round,	clrr MTEMP r	/ Reset sign flag
	gosub absa 	/ Make positive

	stflag c clr
	gosub slc 	/ Multiply remainder by 2

	movr REGB3 a 	/ Test if remainder (REGC) >= divisor (REGB)
	subr a REGC3 s
	stskip z set
	goto rtstgt

	movr REGB2 a
	subr a REGC2 s
	stskip z set
	goto dtstgt

	movr REGB1 a
	subr a REGC1 s
	stskip z set
	goto rtstgt

	movr REGB0 a
	subr a REGC0 s
rtstgt,	stskip c set  	/ Carry set if remainder >= divisor
	goto rremlt

	incrsz REGA0 r 	/ Add 1 to quotient
	goto rremlt

	incrsz REGA1 r
	goto rremlt

	incrsz REGA2 r
	goto rremlt

	incr REGA3 r
	stskip z clr
	return  	/ Overflow,return carry set

rremlt,	skipbc MTEMP 0 	/ Restore sign
	gosub negatea
	return

/ ------------------------------------------
/ 32 BIT SQUARE ROOT
/ sqrt(REGA) -> REGA
/ Return carry set if negative

sqrt,	rotl REGA3 a 	/ Trap negative values
	stskip c clr
	return

	gosub movac 	/ Move REGA to REGC
	gosub clrba 	/ Clear remainder (REGB) and root (REGA)

	movva #D16 	/ Loop counter
	movr a MCOUNT

sqloop,	rotl REGC0 r 	/ Shift two msb's
	rotl REGC1 r 	/ into remainder
	rotl REGC2 r
	rotl REGC3 r
	rotl REGB0 r
	rotl REGB1 r
	rotl REGB2 r
	rotl REGC0 r
	rotl REGC1 r
	rotl REGC2 r
	rotl REGC3 r
	rotl REGB0 r
	rotl REGB1 r
	rotl REGB2 r

	stflag c set  	/ Add 1 to root
	rotl REGA0 r 	/ Align root
	rotl REGA1 r
	rotl REGA2 r

	movr REGA2 a 	/ Test if remdr (REGB) >= root (REGA)
	subr a REGB2 s
	stskip z set
	goto ststgt

	movr REGA1 a
	subr a REGB1 s
	stskip z set
	goto ststgt

	movr REGA0 a
	subr a REGB0 s
ststgt,	stskip c set  	/ Carry set if remdr >= root
	goto sremlt

	movr REGA0 a 	/ Subtract root (REGA) from remdr (REGB)
	subr a REGB0 t
	movr REGA1 a
	stskip c set
	incrsz REGA1 a
	subr a REGB1 t
	movr REGA2 a
	stskip c set
	incrsz REGA2 a
	subr a REGB2 t
	setb REGA0 1 	/ Set current root bit

sremlt,	clrb REGA0 0 	/ Clear test bit
	decrsz MCOUNT r	/ Next
	goto sqloop

	stflag c clr
	rotr REGA2 r 	/ Adjust root alignment
	rotr REGA1 r
	rotr REGA0 r
	return

/ ------------------------------------------
/ 32 BIT SIGNED BINARY TO DECIMAL
/ REGA -> DIGITS 1 (MSD) TO 10 (LSD) & DSIGN
/ DSIGN = 0 if REGA is positive, 1 if negative
/ Return carry set if overflow

bin2dec,	clrr MTEMP r	/ Reset sign flag
	gosub absa 	/ Make REGA positive
	stskip c clr
	return  	/ Overflow

	gosub clrdig 	/ Clear all digits
	movva #D32 	/ Loop counter
	movr a MCOUNT

b2dloop,	rotl REGA0 r 	/ Shift msb into carry
	rotl REGA1 r
	rotl REGA2 r
	rotl REGA3 r

	movva DIGIT10
	movr a Indr 	/ Pointer to digits
	movva #D10 	/ 10 digits to do
	movr a DCOUNT

adjlp,	rotl i i 	/ Shift digit and carry 1 bit left
	movva #D10
	subr a i s 	/ Check and adjust for decimal overflow
	stskip c clr
	movr a i

	decr Indr r 	/ Next digit
	decrsz DCOUNT r
	goto adjlp

	decrsz MCOUNT r	/ Next bit
	goto b2dloop

	skipbc MTEMP 0 	/ Check sign
	setb DSIGN 0 	/ Negative
	stflag c clr
	return

/ ------------------------------------------
/ 32 BIT SIGNED DECIMAL TO BINARY
/ Decimal DIGIT1 thro DIGIT(X) & DSIGN -> REGA
/ Set DSIGN = 0 for positive, DSIGN = 1 for negative values
/ Most significant digit in DIGIT1
/ Enter this routine with digit count in AC register
/ Return carry set if overflow

dec2bin,	movr a MTEMP	/ Save digit count
	movva #D32	/ Outer bit loop counter
	movr a MCOUNT

d2blp1,	movva DIGIT1M1	/ Set up pointer to MSD
	movr a Indr
	movr MTEMP a 	/ Inner digit loop counter
	movr a DCOUNT

	movva #D10
	stflag c clr  	/ Bring in '0' bit into MSD

d2blp2,	incr Indr r
	stskip c clr
	addr a i t 	/ Add 10 if '1' bit from prev digit
	rotr i i 	/ Shift out LSB of digit
	decrsz DCOUNT r	/ Next L.S. Digit
	goto d2blp2

	rotr REGA3 r 	/ Shift in carry from digits
	rotr REGA2 r
	rotr REGA1 r
	rotr REGA0 r
	decrsz MCOUNT r	/ Next bit
	goto d2blp1

	movr i a 	/ Check for overflow
	addva #$FF
	stskip c set
	rotl REGA3 a
	stskip c clr
	return

	skipbc DSIGN 0 	/ Check result sign
	gosub negatea 	/ Negative
	return

/ ------------------------------------------
/ UTILITY ROUTINES

/ ------------------------------------------
/ Add REGB to REGA (Unsigned)

addba,	movr REGB0 a 	/ Add lo byte
	addr a REGA0 t

	movr REGB1 a 	/ Add mid-lo byte
	stskip c clr  	/ No carry_in, so just add
	incrsz REGB1 a 	/ Add carry_in to REGB
	addr a REGA1 t 	/ Add and propagate carry_out

	movr REGB2 a 	/ Add mid-hi byte
	stskip c clr
	incrsz REGB2 a
	addr a REGA2 t

	movr REGB3 a 	/ Add hi byte
	stskip c clr
	incrsz REGB3 a
	addr a REGA3 t
	return

/ ------------------------------------------
/ Move REGA to REGC
movac,	movr REGA0 a
	movr a REGC0
	movr REGA1 a
	movr a REGC1
	movr REGA2 a
	movr a REGC2
	movr REGA3 a
	movr a REGC3
	return

/ ------------------------------------------
/ Clear REGB and REGA
clrba,	clrr REGB0 r
	clrr REGB1 r
	clrr REGB2 r
	clrr REGB3 r

/ ------------------------------------------
/ Clear REGA
clra,	clrr REGA0 r
	clrr REGA1 r
	clrr REGA2 r
	clrr REGA3 r
	return

/ ------------------------------------------
/ Check sign of REGA and convert negative to positive
absa,	rotl REGA3 a
	stskip c set
	return  	/ Positive

/ ------------------------------------------
/ Negate REGA
negatea,	movr REGA3 a 	/ Save sign in w
	andva #$80

	compr REGA0 r 	/ 2's complement
	compr REGA1 r
	compr REGA2 r
	compr REGA3 r

	incrsz REGA0 r
	goto nega1

	incrsz REGA1 r
	goto nega1

	incrsz REGA2 r
	goto nega1

	incr REGA3 r
nega1,	incr MTEMP r 	/ flip sign flag
	addr a REGA3 s 	/ Return carry set if -2147483648
	return

/ ------------------------------------------
/ Check sign of REGB and convert negative to positive
absb,	rotl REGB3 a
	stskip c set
	return  	/ Positive

/ ------------------------------------------
/ Negate REGB
negateb,	movr REGB3 a 	/ Save sign in a
	andva #$80

	compr REGB0 r 	/ 2's complement
	compr REGB1 r
	compr REGB2 r
	compr REGB3 r
	incrsz REGB0 r
	goto negb1

	incrsz REGB1 r
	goto negb1

	incrsz REGB2 r
	goto negb1

	incr REGB3 r	
negb1,	incr MTEMP r 	/ flip sign flag
	addr a REGB3 s	/ Return carry set if -2147483648
	return

/ ------------------------------------------
/ Shift left REGA and REGC
slac,	rotl REGA0 r
	rotl REGA1 r
	rotl REGA2 r
	rotl REGA3 r
slc,	rotl REGC0 r
	rotl REGC1 r
	rotl REGC2 r
	rotl REGC3 r
	return

/ ------------------------------------------
/ Set all digits to 0
clrdig,	clrr DSIGN r
	clrr DIGIT1 r
	clrr DIGIT2 r
	clrr DIGIT3 r
	clrr DIGIT4 r
	clrr DIGIT5 r
	clrr DIGIT6 r
	clrr DIGIT7 r
	clrr DIGIT8 r
	clrr DIGIT9 r
	clrr DIGIT10 r
	return
