/ EDUC8 WIF 8 DIGIT RPN CALCULATOR
/ [KEYPAD 2] TO DEV0 INPUT - THE STANDARD KEY LABELS WILL WORK WITH THIS PROJECT
/ (A keypad file called [calc.kpf] also has the calculator key legends)
/ [10 DIGIT DISPLAY] TO DEV0 OUTPUT
/
/ THE CALCULATOR ALORITHMS WERE ADAPTED FROM CODE THAT WAS ORINIALLY
/ USED IN SOME SCIENTIFIC CALCULATORS FROM THE SAME SEVENTIES ERA AS THE EDUC-8.
/ THOSE CALCULATOR SYSTEM CLOCKS WERE MUCH FASTER THAN THE EDUC-8 COMPUTER,
/ AS SUCH THIS CALCULATOR IS A BIT SLOW, ESPECIALLY THE DIVIDE ROUTINE.
/ FASTER ROUTINES COULD BE DESIGNED IF REQUIRED - SEE 32 BIT MATH FILE
/
/ THE BCD MATH ROUTINES HERE ACTUALLY CATER FOR NUMBERS IN THE RANGE...
/   +/-9.999999999 E+/-99
/ BUT THE CALCULATED RESULTS HAVE BEEN LIMITED TO JUST 8 DIGITS

/ OPERATION:
/ THE CALCULATOR IS BASED ON REVERSE POLISH NOTATION (RPN)
/ IE: THERE IS NO EQUALS KEY
/ NUMBER ENTRY AND CALCULATION IS IN THE FORM...
/   NUMA -> ENT -> NUMB -> (FUNCTION)

/ EG: 8 + 5                - KEY IN -> 8 ENT 5 +                          = 13
/ EG: 8 + (23 / 35)        - KEY IN -> 23 ENT 35 / 8 +                    = 8.6571428
/ The last answer should be 8.6571429, but the last digit is not
/ rounded up due to insufficient code memory remaining to accomplish the task
/ EG: (7 / 23) + (9 * 1.2) - KEY IN -> MC 7 ENT 23 / M+ 9 ENT 1.2 x M+ RM = 11.104347
/ Should be 11.104348 but still has no last digit rounding
/ EG: 7 * -9               - KEY IN -> 7 ENT 9 CHS x                      = -63
/ EG: Reciprocal of 9.9    - KEY IN -> 9.9 1/x                            = 0.1010101
/ EG: -48.67 squared       - KEY IN -> 48.67 CHS ENT x                    = 2368.7689
/ EG. Square root 89.234   - KEY IN -> 89.234 SQR                         = 9.4463749
/ EG. Square root -39      - KEY IN -> 39 CHS SQR                         = Error
/
/ The "Error" display can be cleared by pressing any key.

/ Note: Internally, the mantissa numbers are 10 BCD digits long
/       although only 8 digits are displayed
/ EG 1/47 = 0.0212765, 1/x again gives 47
/ Internally 1/47 is 0.021276596, 1/x again internally is 47.00000001
/ Check out these calculator results in regC using the WIF RAM Viewer

/ Maybe you can redeign the calculator to have an equals sign :-)

	_RAM
Indrirect	/ 0: reserved for Indr address
RAMdata
TempA
TempB
TempC
TempD
genBits
genBits2
NibbH
NibbL
DigPos
regP
XregA
XregB
regA :#D7
regC :#D7
regB :#D7
regM :#D7
disBuff :#D10

	_ENDRAM

/ genBits bit defines
_CONST DPfirst   #D0
_CONST ERflag    #D1
_CONST XferHA    #D2

_CONST DBzeros   #D4
_CONST retMP     #D5
_CONST DPent     #D6
_CONST NWnum     #D7

/ genBits2 bit defines
_CONST nzMant    #D0
_CONST DPflag    #D1
_CONST NEWnum    #D2
_CONST HLnibb    #D3
_CONST HILOswap  #$08	/ bit mask in genBits2 for HLnibb
_CONST MDAS      #D4
_CONST bCarry    #D5
_CONST regXa     #D6
_CONST regXb     #D7

_CONST regA0     regA + #D6
_CONST regC5     regC + #D1
_CONST regC4     regC + #D2
_CONST regC0     regC + #D6
_CONST buffInit  disBuff + #D1
_CONST buff2     disbuff + #D2
_CONST buff3     disbuff + #D3
_CONST buff4     disbuff + #D4
_CONST buff5     disbuff + #D5
_CONST buff6     disbuff + #D6
_CONST buff7     disbuff + #D7
_CONST buff8     disbuff + #D8
_CONST buffLast  disBuff + #D9
_CONST buffMAX   disBuff + #D10

	_ISWIMODEON

/ RAM used per 14 nibble BCD register = 7 bytes
/ NIBBLE IN RAM, eg regC - 13 12   11 10   9 8   7 6   5 4   3 2   1 0
/ BYTE OFFSET              0       1       2     3     4     5     6
/ 13 12  = Exponent          - [12] = first left digit
/ 11     = Exponent sign  (9 = negative) (0 = positive)
/ 10 - 1 = 10 digit mantissa - [1] = first left digit
/ 0      = Mantissa sign  (9 = negative) (0 = positive)
/ EG: -123.2345 in regC = 20 00 00 54 32 32 19

/ --------------------------------------
start,	movva D10_INI
	writod DEV0 A
	movva D10_BK
	gosub ClrDbuff
	gosub ZeroRegA
	gosub ZeroRegB
	gosub ZeroRegM
	clrb genBits ERflag
	clrr genBits2 r
Cnew,	gosub ZeroRegC
	goto newCdisp
retNWdisp,	clrr genBits r
	movva buffInit
	movr a digPos
retNWkey,	gosub DispOut
dson,	gosub DispON
	
/ --------------------------------------
keywt,	skipif 0	/ wait for key press
	goto keywt

keyserv,	skipbs genBits ERflag
	goto keyDCD

doReset,	reseti 0	/ reset key flag
	goto start

keyDCD,	skipbc genBits NWnum
	gosub DispToC
	romptr H HIGH jumpTB	/ make sure in ROM page 0 for [P] [TGT] instructions
	readid 0 a	/ key press into AC
jumpTB,	addr a p t	/ jump table
	goto inpNum	/ 0
	goto inpNum	/ 1
	goto inpNum	/ 2
	goto inpNum	/ 3
	goto inpNum	/ 4
	goto inpNum	/ 5
	goto inpNum	/ 6
	goto inpNum	/ 7
	goto inpNum	/ 8
	goto inpNum	/ 9
	goto buttDP	/ Decimal Point
	goto buttCS	/ Change sign
	goto doMC	/ Memory Clear
	goto doMR	/ Memory Recall
	goto doMP	/ Memory Plus
	goto doMM	/ Memory Minus
	goto doDIVst	/ Divide
	goto doMULst	/ Multiply
	goto doADDst	/ Add
	goto doSUBst	/ Subtract
	goto doSQRTst	/ SQRT
	goto butt1X	/ Reciprocal
	goto buttCL	/ Clear
	goto buttEN	/ Enter

/ --------------------------------------
butt1X,	gosub ZeroRegA
	movva regA0	/ 1/X
	movr a Indr
	movva #$10
	movr a i
doDIVst,	movva #D12	/ 12 -> p
	gosub preMDAS
	gosub doDIV
	goto errCheck

doMULst,	movva 3	/ 3 -> p
	gosub preMDAS
	gosub doMUL
	goto errCheck
	
buttCS,	skipbs genBits NWnum
	goto ngRegC

	stflag rp set
	movr disBuff a
	xorva D10_NEG
	movva D10_NEG
	stskip z clr
	movva D10_BK
	movr a disBuff
	stflag rp clr
	goto rstKey

ngRegC,	movr regC0 a
	andva #$0F
	xorva 9
	movva 9
	stskip z clr
	movva 0
	movr a TempC
	movr regC0 a
	andva #$F0
	iorr a TempC s
	movr a regC0
	goto newCdisp

buttDP,	movva D10_DP
	goto inpNum

buttCL,	goto Cnew

buttEN,	gosub CintoAW	/ ENTER  C -> a[w]
	goto newCdisp

/ --------------------------------------
doMC,	gosub ZeroRegM	/ memory clear - disp to c
	goto exFuncNN

/ --------------------------------------
doMR,	gosub preCalc	/ memory recall - disp to C, push c to a, then execute
	goto newCdisp

/ --------------------------------------
doMP,	gosub preCalcHA
	gosub doADD
	goto finMPMM

/ --------------------------------------
doMM,	gosub preCalcHA	/ memory plus - disp to C, push c to a, mem to c, then execute
	gosub doSUB

finMPMM,	gosub ouFlow
	skipbc genBits ERflag
	goto keyWt

	gosub setW
	gosub CintoM
	goto exFuncNN

/ --------------------------------------
doADDst,	movva #D12
	gosub preMDAS
	gosub doADD
	goto errCheck

/ --------------------------------------
doSUBst,	movva #D12
	gosub preMDAS
	gosub doSUB
	goto errCheck

/ --------------------------------------
doSQRTst,	movva 4
	gosub preMDAS
	gosub doSQRT
	goto errCheck

/ --------------------------------------
inpNum,	movr a TempC
	movva buffMAX
	skipbs genBits DPent	/ if no DP entered buffer full is buffMAX - 1
	subva 1
	xorr digPos a t
	stskip z clr
	goto rstKey	/ buffer full

	skipbc genBits NWnum
	goto enterDig

	/ if digPos is at first position, if DP, then enter DP with no digit following
	/ if DP entered then no DP at end
	/ if no DP entered, enter number with DP following
	setb genBits NWnum
	movva D10_BK
	gosub ClrDbuff
	gosub CintoAW	/ C -> a[w]
	movva buffInit
	movr a digPos
	movr a Indr

	movr TempC a
	xorva D10_DP
	stskip z set
	goto inptDgt

	setb genBits DPent	/ input a DP with next digit blank
	setb genBits DPfirst
	movva D10_DP
	movr a i
	incr Indr r
	movva D10_BK
	movr a i
	goto nextDig

enterDig,	movr digPos a
	movr a Indr
	movr TempC a
	xorva D10_DP	/ if DP entered, ignore it if already entered
	stskip z set
	goto inptDgt

	skipbc genBits DPent	/ exit if DP already entered
	goto rstKey

	setb genBits DPent
	goto nextDig	/ no display change but set at next digit

inptDgt,	movr TempC a
	movr a i
	skipbc genBits DPent
	goto nextDig

	incr Indr r	/ DP follows digit
	movva D10_DP
	movr a i
nextDig,	incr digPos r
rstKey,	reseti 0	/ reset key flag
	goto retNWkey

/ --------------------------------------
errCheck,	gosub ZeroRegA
newCdisp,	skipbc genBits ERflag
	goto dson

	gosub ouFlow
	skipbc genBits ERflag
	goto dson

	gosub CtoDisp
exFuncNN,	skipbs genBits XferHA
	goto keyUp

keyUp,	reseti 0	/ reset key flag
	goto retNWdisp
/
/ --------------------------
/ SUBROUTINE: SETUP PRE CALC
/ --------------------------
/
preMDAS,	movr a regP
	gosub DispOFF
	gosub ZeroRegB
	setb genBits MDAS
preCalcHA,	setb genBits XferHA
preCalc,	skipbc genBits MDAS
	return

	gosub CintoAW	/ C -> a[w]
	gosub setW
	gosub MintoC
	clrb genBits MDAS
	return

/ ********************************************************************
/ regA x regC -> regC
/ ********************************************************************
doMUL,	gosub setX	/ a + c -> c[x]
	gosub AplusCtoC
	goto div21	/ go to div21
	
/ ********************************************************************
/ regA / regC -> regC
/ ********************************************************************
doDIV,	gosub setX	/ a - c -> c[x]
	gosub AminCtoC
div21,	gosub setS	/ a - c -> c[s]
	gosub AminCtoC
	skipbs genBits2 bCarry	/if no carry go to div22
	goto div22

	gosub setS	/ 0 - c -> c[s]
	gosub TensComp
div22,	gosub XexchXM	/ a exchange b[m]
	gosub ZeroRegA	/ 0 -> a[w]
	movva #D12	/ if p # 12
	xorr a regP s
	stskip z set
	goto mpy27	/ then go to mpy27
	gosub setM	 /if c[m] >= 1
	gosub CmpCto1
	skipbs genBits2 bCarry
	goto div23	/ then go to div23

/ DIV by zero
doError,	movva D10_ERR
	writod DEV0_OUT a
	setb genBits ERflag
	reseti 0	/ reset key flag
	return

div23,	gosub setWP	/ b exchange c[wp]
	gosub XexchXBC
	setb genBits2 regXb
	gosub XexchXM	/ a exchange c[m]
	goto div15

div14,	gosub setP	/ c + 1 -> c[p]
	gosub Cplus1toC
div15,	gosub setMS	/ a - b -> a[ms]
	gosub AminBtoA
	skipbs genBits2 bCarry
	goto div14	/ if no carry go to div14

	gosub setMS	/ a + b -> a[ms]
	gosub AplusBtoA
	gosub setMS	/ shift left a[ms]
	gosub shiftAL
div16,	decrsz regP r	/ p - 1 -> p, if p # 0
	goto div15	/ then go to div15

tnm12,	gosub CintoAW	/ C -> a[w]
	gosub setX
	gosub BintoC	/ b -> c[x]
	goto nrm21	/ go to nrm21

/ ********************************************************************
/ regA - regC -> regC
/ ********************************************************************
doSUB,	gosub NinesComp	/ 0 - c - 1 -> c[s]

/ ********************************************************************
/ regA x regC -> regC
/ ********************************************************************
doADD,	gosub Apl1toAXS	/ a + 1 -> a[xs]
	gosub Apl1toAXS	/ a + 1 -> a[xs]
	gosub Cpl1toCXS	/ c + 1 -> c[xs]
	gosub Cpl1toCXS	/ c + 1 -> c[xs]

	gosub setX	/ if a >= c[x]
	gosub CompAtoC
	skipbs genBits2 bCarry	/ then go to add4
	goto add4

	gosub setW	/ a exchange c[w]
	setb genBits2 regXb
	gosub XexchX

add4,	setb genBits2 regXb
	gosub XexchXM	/ a exchange c[m]
	gosub setM
	gosub CmpCto0	/ if c[m] = 0
	skipbs genBits2 bCarry	/ then go to add5
	goto add5

	gosub setW	/ a exchange c[w]
	setb genBits2 regXb
	gosub XexchX

add5,	gosub setM	/ b exchange c[m]
	gosub XexchXBC
add6,	gosub setX	/ if a >= c[x]
	gosub CompAtoC
	skipbs genBits2 bCarry	/ then go to add12
	goto add12

/add8,	gosub setW	/ shift right b[w]
add8,	setb genBits2 regXa
	gosub shiftXR / shiftBR
	gosub setX	/a + 1 -> a[x]
	gosub Aplus1toA
	gosub setW	/ if b[w] = 0
	gosub ifBeq0
	skipbs genBits2 bCarry	/ then go to add12
	goto add12
	goto add6

add12,	gosub setXS	/ c - 1 -> c[xs]
	gosub CMin1toC
	gosub setXS	/ c - 1 -> c[xs]
	gosub CMin1toC
	gosub setX	/ 0 -> a[x]
	gosub ZeroA
	gosub setS	/ a - c -> a[s]
	gosub AminCtoA
	gosub Agreq1S	/ if a[s] >= 1
	skipbs genBits2 bCarry	/ then go to add13
	goto add13
	goto mpy26

add13,	gosub setM	/ if a >= b[m]
	gosub AgreqB
	skipbs genBits2 bCarry	/ then go to add14
	goto add14

	gosub NinesComp	/ 0 - c - 1 -> c[s]
	gosub setW	/ a exchange b[w]
	gosub XexchX
add14,	gosub setW	/ a - b -> a[w]
	gosub AminBtoA
add15,	goto nrm21

mpy26,	gosub AplusBtoAW	/ a + b -> a[w]
mpy27,	gosub setP	/ c - 1 -> c[p]
	gosub CMin1toC
	skipbs genBits2 bCarry	/ if no carry go to mpy26
	goto mpy26

mpy28,	gosub shiftXR	/ shift right a[w]
	incr regP r	/ p + 1 -> p
	movva #D13	/ if p # 13
	xorr a regP s
	stskip z set
	goto mpy27	/ then go to mpy27

nrm20,	gosub setX	/ c + 1 -> c[x]
	gosub Cplus1toC
nrm21,	gosub setS	/ 0 -> a[s]
	gosub ZeroA
	movva #D12	/12 -> p
	movr a regP
	gosub ZeroRegB	/ 0 -> b[w]
nrm23,	gosub setP	/ if a[p] >= 1
	gosub Agreq1
	stskip z set
	goto nrm24	/ then go to nrm24

	gosub shiftALW	/ shift left a[w]
	gosub setX	/ c - 1 -> c[x]
	gosub CMin1toC
	gosub setW	/ if a[w] >= 1
	gosub Agreq1
	stskip z set
	goto nrm23	/ then go to nrm23

	gosub ZeroRegC	/ 0 -> c[w]
nrm24,	gosub setX	/ a -> b[x]
	gosub AintoB
	gosub AplusBtoAW	/ a + b -> a[w]
	gosub Agreq1S	/ if a[s] >= 1
	stskip z set
	goto mpy28	/ then go to mpy28

	setb genBits2 regXb
	gosub XexchXM	/ a exchange c[m]

/ ********************************************************************
	return	/ ANSWER IN regC
/ ********************************************************************
/
/ --------------------------------
/ ARM Type XX - Exchange R1 and R2
/ --------------------------------
/
XexchXBC,	setb genBits2 regXa	/ b exchange c
	setb genBits2 regXb
	goto XexchX
XexchXM,	gosub setM
XexchX,	movva regA
	skipbc genBits2 regXa
	movva regB
	movr a XregA

	movva regB
	skipbc genBits2 regXb
	movva regC
	movr a XregB

XexchXlp,	movr XregA a	/movva regB
	gosub GETnibble
	movr a TempB
	movr XregB a	/movva regC
	gosub GETnibble

	movr XregA a	/movva regB
	gosub PUTnibble
	movr TempB a
	movr a RAMdata
	movr XregB a	/movva regC
	gosub PUTnibble

	gosub NextNib
	stskip z set
	goto XexchXlp
	goto rstComBts
/
/ --------------------------
/ ARM Type XX - SHIFT R W R1
/ --------------------------
/
shiftXR,	gosub setW	/ shift right x[w]
INshiftR,	movva regA
	skipbs genBits2 regXa
	goto startRS
	movva regB
	skipbc genBits2 regXb
	movva regC

startRS,	movr a XregA
shiftXRlp,	incr NibbL r
	movr XregA a
	gosub GETnibble
	decr NibbL r
	movr XregA a
	gosub PUTnibble

	gosub NextNib
	stskip z set
	goto shiftXRlp

	movr NibbH a
	movr a NibbL
	clrr RAMdata r
	movr XregA a
	gosub PUTnibble
rstComBts,	clrb genBits2 regXa
	clrb genBits2 regXb
	return
/
/ ----------------------------
/ ARM Type 00 - Compare B to 0
/ ----------------------------
/
ifBeq0,	movva regB
	gosub GETnibble
	stskip z set
	goto setBcarry

	gosub NextNib
	stskip z set
	goto ifBeq0
	return

setBcarry,	setb genBits2 bCarry
	return
/
/
/ ----------------------------
/ ARM Type 02 - Compare A to C
/ ----------------------------
/
CompAtoC,	movva regA
	gosub GETnibble
	movr a TempB
	movva regC
	gosub GETnibble
	gosub SUBnibble

	gosub NextNib
	stskip z set
	goto CompAtoC
	return
/
/ ----------------------------
/ ARM Type 03 - Compare C to 1
/ ----------------------------
/
CmpCto1,	setb genBits2 bCarry
inARM03,	movva regC
	gosub GETnibble
	stskip z set
	goto clrBcarry

	gosub NextNib
	stskip z set
	goto inARM03
	return

clrBcarry,	clrb genBits2 bCarry
	return
/
/ ----------------------------
/ ARM Type 13 - Compare C to 0
/ ----------------------------
/
CmpCto0,	movva regC
	gosub GETnibble
	stskip z set
	goto setBcarry

	gosub NextNib
	stskip z set
	goto CmpCto0
	return
/
/ ----------------------------------------
/ ARM Type 07 - 0-C-1->C 9's Comp C into C
/ ----------------------------------------
/
NinesComp,	gosub setS
	setb genBits2 bCarry
/
/ --------------------------------
/ ARM Type 05 - 10's Comp C into C
/ --------------------------------
/
TensComp,	clrr TempB r
	movva regC
	gosub GETnibble
	gosub SUBnibble
	movr a RAMdata
	movva regC
	gosub PUTnibble

	gosub NextNib
	stskip z set
	goto TensComp
	return
/
/ --------
/ M into C
/ --------
/
MintoC,	movva regM
	movr a XregA
	movva regC
	goto XintoX
/
/ --------
/ C into M
/ --------
/
CintoM,	movva regC
	movr a XregA
	movva regM
	goto XintoX
/
/ ----------------------
/ ARM Type 12 - C into A
/ ----------------------
/
CintoAW,	gosub setW
CintoA,	movva regC
	movr a XregA
	movva regA
	goto XintoX
/
/ ----------------------
/ ARM Type 09 - A into B
/ ----------------------
/
AintoB,	movva regA
	movr a XregA
	movva regB
	goto XintoX
/
/ ----------------------
/ ARM Type 04 - B into C
/ ----------------------
/
BintoC,	movva regB
	movr a XregA
	movva regC
XintoX,	movr a XregB
inXinX,	movr XregA a
	gosub GETnibble
	movr XregB a
	gosub PUTnibble

	gosub NextNib
	stskip z set
	goto inXinX
	return
/
/ --------------------------
/ ARM Type 08 - Shift A Left
/ --------------------------
/
shiftALW,	gosub setW
shiftAL,	movr NibbL a
	movr a TempA
	movr NibbH a
	movr a NibbL
	movr TempA a
	movr a NibbH

InARM08,	decr NibbL r
	movva regA
	gosub GETnibble
	incr NibbL r
	movva regA
	gosub PUTnibble

	gosub PrevNib
	stskip z set
	goto InARM08

	movr NibbH a
	movr a NibbL
	clrr RAMdata r
	movva regA
	gosub PUTnibble
	return
/
/ ---------------------------
/ ARM Type 10 -> A - C into C
/ ---------------------------
/
AminCtoC,	movva regA
	gosub GETnibble
	movr a TempB
	movva regC
	gosub GETnibble
	gosub SUBnibble
	movr a RAMdata
	movva regC
	gosub PUTnibble

	gosub NextNib
	stskip z set
	goto AminCtoC
	return
/
/ -------------------------
/ ARM Type 11 - Decrement C
/ -------------------------
/
CMin1toC,	setb genBits2 bCarry
inARM11,	movva regC
	gosub GETnibble
	movr a TempB
	movva 0
	gosub SUBnibble
	movr a RAMdata
	movva regC
	gosub PUTnibble

	gosub NextNib
	stskip z set
	goto inARM11
	return
/
/ ---------------------------
/ ARM Type 14 -> A + C into C
/ ---------------------------
/
AplusCtoA,	movva regA
	goto inAplX
AplusCtoC,	movva regC
inAplX,	movr a XregA
AplClp,	movva regA
	gosub GETnibble
	movr a TempB
	movva regC
	gosub GETnibble
	gosub ADDnibble
	movr a RAMdata
	movr XregA a
	gosub PUTnibble

	gosub NextNib
	stskip z set
	goto AplClp
	return
/
/ -------------------------
/ ARM Type 15 - Increment C
/ -------------------------
/
Cpl1toCXS,	gosub setXS
Cplus1toC,	setb genBits2 bCarry
inARM15,	movva regC
	gosub GETnibble
	clrr TempB r
	gosub ADDnibble
	movr a RAMdata
	movva regC
	gosub PUTnibble

	gosub NextNib
	stskip z set
	goto inARM15
	return
/
/ ----------------------------
/ ARM Type 16 - Compare A to B
/ ----------------------------
/
AgreqB,	movva regA
	gosub GETnibble
	movr a TempB
	movva regB
	gosub GETnibble
	gosub SUBnibble

	gosub NextNib
	stskip z set
	goto AgreqB
	return
/
/ ----------------------------
/ ARM Type 19 - Compare A to 1
/ ----------------------------
/
Agreq1S,	gosub setS
Agreq1,	setb genBits2 bCarry
inARM19,	movva regA
	gosub GETnibble
	stskip z set
	goto clrBcarry

	gosub NextNib
	stskip z set
	goto inARM19
	return
/
/ ---------------------
/ ARM Type 23 - Clear A
/ ---------------------
/
ZeroC,	movva regC
	goto inZAC
ZeroA,	movva regA
inZAC,	movr a XregA
	clrr RAMdata r
inARM23,	movr XregA a
	gosub PUTnibble

	gosub NextNib
	stskip z set
	goto inARM23
	return
/
/ --------------------------
/ ARM Type 24 - A - B into A
/ --------------------------
/
AminBtoA,	movva regA
	gosub GETnibble
	movr a TempB
	movva regB
	gosub GETnibble
	gosub SUBnibble
	movr a RAMdata
	movva regA
	gosub PUTnibble

	gosub NextNib
	stskip z set
	goto AminBtoA
	return
/
/ --------------------------
/ ARM Type 26 - A - C into A
/ --------------------------
/
AminCtoA,	movva regA
	gosub GETnibble
	movr a TempB
	movva regC
	gosub GETnibble
	gosub SUBnibble
	movr a RAMdata
	movva regA
	gosub PUTnibble

	gosub NextNib
	stskip z set
	goto AminCtoA
	return
/
/ --------------------------
/ ARM Type 28 - A + B into A
/ --------------------------
/
AplusBtoAW,	gosub setW
AplusBtoA,	movva regA
	gosub GETnibble
	movr a TempB
	movva regB
	gosub GETnibble
	gosub ADDnibble
	movr a RAMdata
	movva regA
	gosub PUTnibble

	gosub NextNib
	stskip z set
	goto AplusBtoA
	return
/
/ -------------------------
/ ARM Type 31 - Increment A
/ -------------------------
/
Apl1toAXS,	gosub setXS
Aplus1toA,	setb genBits2 bCarry
inARM31,	movva regA
	gosub GETnibble
	clrr TempB r
	gosub ADDnibble
	movr a RAMdata
	movva regA
	gosub PUTnibble

	gosub NextNib
	stskip z set
	goto inARM31
	return
/
/ -----------------------------------
/ SUBROUTINE: GET NIBBLE ROM REGISTER
/ -----------------------------------
/ Entry - Register address in W, Nibble (0 - 13) in NibbL
/ Result in W and RAMdata
/
GETnibble,	movr a Indr
gnibok,	stflag c clr	/ 2 nibbles per ram address
	rotr NibbL a
	movr a TempD
	movr Indr a
	addr a TempD s
	movr a Indr

	movr i a
	skipbs NibbL 0
	exchr i a
	andva #$0F
	movr a RAMdata
	return
/
/ ------------------------------------
/ SUBROUTINE: PUT NIBBLE INTO REGISTER - only used for regA etc, not RAM storage
/ ------------------------------------
/ Entry - Register address in W, Nibble (0 - 13) in NibbL
/       - Data in RAMdata
/
PUTnibble,	movr a Indr
pnibok,	stflag c clr	/ 2 nibbles per ram address
	rotr NibbL a
	movr a TempD
	movr Indr a
	addr a TempD s
	movr a Indr

	movr RAMdata a
	skipbs NibbL 0
	exchr RAMdata a
	movr a TempA

	movva #$F0
	skipbs NibbL 0
	movva #$0F
	andr i a t
	iorr a TempA s
	movr a i
	return
/
/ ----------------------
/ SUBROUTINE: Add Nibble
/ ----------------------
/ AC + TempB -> AC - sets Calc carry
/
ADDnibble,	addr a TempB s
	skipbc genBits2 bCarry
	addva 1

	skipifa >= #D10
	goto clrBcarry

	subva #D10
	goto setBcarry
/
/ ----------------------
/ SUBROUTINE: Sub Nibble
/ ----------------------
/ TempB - AC -> AC - sets Calc carry
/
SUBnibble,	skipbc genBits2 bCarry
	addva 1
	subr a TempB s

	stskip c clr
	goto clrBcarry

	addva #D10
	goto setBcarry
/
/ ----------------------------------
/ SUBROUTINE: Increment nibble index
/ ----------------------------------
/ Z flag = Set if nibble count = match
/
NextNib,	movr NibbH a
	xorr a NibbL s
	stskip z set
	incr NibbL r
	return
/
/ ----------------------------------
/ SUBROUTINE: Decrement nibble index
/ ----------------------------------
/ Z flag = 0 if count = 0
/
PrevNib,    decr NibbL r
	movr NibbH a
	xorr a NibbL s
	return
/
/ ---------------------------------
/ SUBROUTINE: Set NibbL NibbH for X
/ ---------------------------------
/
setX,	clrb genBits2 bCarry
	clrr NibbL r
	movva 2
retNibbs,	movr a NibbH
	clrb genBits2 bCarry
	return
/
/ ---------------------------------
/ SUBROUTINE: Set NibbL NibbH for S
/ ---------------------------------
/
setS,	movva #D13
	movr a NibbL
	goto retNibbs
/
/ ----------------------------------
/ SUBROUTINE: Set NibbL NibbH for WP
/ ----------------------------------
/
setWP,	clrr NibbL r
	movr regP a
	goto retNibbs
/
/ ---------------------------------
/ SUBROUTINE: Set NibbL NibbH for M
/ ---------------------------------
/
setM,	movva 3
	movr a NibbL
	movva #D12
	goto retNibbs
/
/ ----------------------------------
/ SUBROUTINE: Set NibbL NibbH for MS
/ ----------------------------------
/
setMS,	movva 3
	movr a NibbL
	movva #D13
	goto retNibbs
/
/ ---------------------------------
/ SUBROUTINE: Set NibbL NibbH for P
/ ---------------------------------
/
setP,	movr regP a
	movr a NibbL
	goto retNibbs
/
/ ----------------------------------
/ SUBROUTINE: Set NibbL NibbH for XS
/ ----------------------------------
/
setXS,	movva 2
	movr a NibbL
	goto retNibbs
/
/ ---------------------------------
/ SUBROUTINE: Set NibbL NibbH for W
/ ---------------------------------
/
setW,	clrr NibbL r
	movva #D13
	goto retNibbs
/
/ ----------------------------
/ SUBROUTINE: CLEAR A REGISTER
/ ----------------------------
/
ZeroRegM,	movva regM
	goto ZeroReg
ZeroRegA,	movva regA
	goto ZeroReg
ZeroRegB,	movva regB
	goto ZeroReg
ZeroRegC,	movva regC
ZeroReg,	movr a Indr
	movva 7
	movr a TempA
clrClp,	clrr i i
	incr Indr r
	decrsz TempA r
	goto clrClp
	return
/
/ --------------------------------
/ SUBROUTINE: CLEAR DISPLAY BUFFER
/ --------------------------------
/
ClrDbuff,	movr a NibbH
	movva disBuff
	movr a Indr
	movva #D10
	movr a TempD
	movr NibbH a
CDBlp,	movr a i
	incr Indr r
	decrsz TempD r
	goto CDBlp
	return
/
/ --------------------------------
/ SUBROUTINE: OUTPUT DISPLY BUFFER
/ --------------------------------
/
DispOut,	movva disBuff
	movr a Indr
	movva #D10
	movr a TempA

	movva D10_IDX
	writod DEV0_OUT a	/ CMD 8X = set display index to 0

DOloop,	movr i a
	writod DEV0_OUT a
	incr Indr r
	decrsz TempA r
	goto DOloop
	return
/
/ ---------------------------
/ SUBROUTINE: TURN DISPLAY ON
/ ---------------------------
/
DispON,	movva D10_ON
	goto DispSet
/
/ ----------------------------
/ SUBROUTINE: TURN DISPLAY OFF
/ ----------------------------
/
DispOFF,	movva D10_OFF
DispSet,	WRITOD DEV0 A
	return
/
/ ---------------------------------
/ SUBROUTINE: regC TO DISPAY BUFFER
/ ---------------------------------
/
CtoDisp,	clrr genBits2 r
	gosub setM	/ if regC mantissa = 0, then clear regC
	gosub CmpCto0
	skipbs genBits2 bCarry
	gosub ZeroRegC

	movva 0
	gosub ClrDbuff
	movva 1
	movr a DigPos	/ digit pos after sign

/ set sign
	movva regC0
	movr a Indr
	movr i a
	andva #$0F
	movva D10_BK
	stskip z set
	movva D10_NEG
	movr a TempA

	movva DisBuff
	movr a Indr
	movr TempA a
	movr a i

/ insert decimal point according to exponent
/ +ve exp,  DP pos = exp + 2, digits start at [1]
/ -ve exp , DP pos = 2,       digits start at [11-Exp]

	movva DisBuff
	movr a NibbH	/ DP position

	movva regC
	movr a Indr
	exchr i a
	andva #$0F
	movr a TempA	/ exponent digit
	incr Indr r
	movr i a	/ exponent sign
	andva #$F0
	stskip z set
	goto CnegExp

	movva regC
	movr a Indr
	movr TempA a
	addva 2
	addr a NibbH t	/ DP position
	movva 1
	goto XferRegC

CnegExp,	movva regC
	movr a Indr
	movva 2
	addr a NibbH s	/ DP position
	movr a Indr
	movva D10_DP
	movr a i
	clrr NibbH r	/ no DP match later
	
	movva #D12
	subr TempA a t
	
/ transfer regC to display buffer
XferRegC,	addva DisBuff
	movr a DigPos	/ Digits start position

/ digits start at regC high nibble
	movva regC0
	movr a TempA	/ regC pointer
	setb genBits2 HLnibb	/ get HI regC nibble first

CtoDlp,	movr TempA a	/ get regC nibble
	movr a Indr
	movr i a
	movr a NibbL	/ temp save nibble
	skipbc genBits2 HLnibb	/ point to next nibble if this is HI nibble
	decr TempA r	/ next nibble

/ insert DP ?
	movr DigPos a
	movr a Indr
	xorr a NibbH s
	stskip z set
	goto noDPyet

	movva D10_DP	/ place DP in buffer
	movr a i
	incr Indr r
	incr DigPos r
 	
noDPyet,	movr NibbL a	/ HI nibble
	skipbc genBits2 HLnibb
	exchr NibbL a	/ LO nibble
	andva #$0F
	movr a i

	movr DigPos a	/ if DigPos >= buffMAX then stop entering data
	skipifa < buffMAX
	goto DelTrZrs

	incr DigPos r
	movva HILOswap	/ alternate H or L nibble
	xorr a genBits2 t
	goto CtoDlp

/ blank out training zeros
DelTrZrs,	movva DisBuff
	addva 9
	movr a Indr
DTZlp,	movr i a
	xorva 0
	stskip z set
	return	/ done

	movva D10_BK
	movr a i
	decr Indr r
	goto DTZlp
/
/ ---------------------------------------
/ SUBROUTINE: GET DISPLAY DIGIT - DispToC
/ ---------------------------------------
/
getDisDigt,	movr TempB a	/ get display buffer item
	movr a Indr
	xorva buffMAX
	stskip z clr
	return	/ Z flag set for end of buffer

	movr i a
	movr a RAMdata	/ temp store
	incr TempB r	/ next digit, Z flag will always be clear
	return
/
/ --------------------------------------------
/ SUBROUTINE: CONVERT DISPLAY BUFFER INTO regC
/ --------------------------------------------
/ disBuff might just have a -ve and or DP with no digits - if so, regC = 0
/
DispToC,	clrr genBits2 r
	gosub ZeroRegC
	movva regC0
	movr a TempA	/ regC pointer
	movva disBuff
	movr a TempB	/ disBuff pointer

	gosub getDisDigt
	xorva D10_NEG
	stskip z set
	goto DtoClp

	movva regC0	/ point to regC exp sign
	movr a Indr
	movva #$09	/ negative mantissa
	movr a i

DtoClp,	gosub getDisDigt
	stskip z clr
	goto zerRegC	/ end of buffer

	xorva D10_BK
	stskip z clr
	goto zerRegC	/ no more digits in buffer

	movr RAMdata a
	xorva D10_DP
	stskip z set
	goto notDP

	setb genBits2 DPflag
	skipbc genBits2 NEWnum	/ if DP was first digit, then negative exponent
	goto DtoClp

	movva regC
	movr a Indr
	movva #$99	/ set exp - -ve 99a
	movr a i
	incr Indr r
	movva #$90
	movr a i
	goto DtoClp

notDP,	skipbs genBits2 DPflag
	goto t1stdg	/ DP set, see if neg exponent

	skipbc genBits2 NEWnum	/ if DP was first digit, then negative exponent
	goto digitToC
	
	movr RAMdata a
	stskip z set
	goto nt1stdgt

	movva regC	/ point to regC exp sign
	movr a Indr
	movva #$10
	subr a i t	/ decrement it
	goto DtoClp

t1stdg,	skipbc genBits2 NEWnum
	goto incExp

nt1stdgt,	setb genBits2 NEWnum
	goto digitToC

incExp,	movva regC	/ point to regC exp sign
	movr a Indr
	movva #$10	/ increment exp
	addr a i t

digitToC,	movr TempA a	/ set regC pointer
	movr a Indr
	skipbc genBits2 HLnibb	/ put value in HI or LO nibble
	goto lowCnibb

	setb genBits2 HLnibb	/ low nibble next
	decr TempA r	/ next regC nibble next
	exchr RAMdata r
	movr i a
	andva #$0F
	goto nextC

lowCnibb,	clrb genBits2 HLnibb	/ high nibble next
	movr i a
	andva #$F0
nextC,	iorr a RAMdata s
	movr a i
	setb genBits2 nzMant
	goto DtoClp

/ if mantissa = 0 then clear regC
zerRegC,	skipbs genBits2 nzMant
	gosub ZeroRegC
	return
/
/ ------------------------------------
/ SUBROUTINE: CHECK FOR UNDER/OVERFLOW
/ ------------------------------------
/
ouFlow,	setb genBits ERflag
	movva regC5
	movr a Indr
	movr i a	/ exponent sign
	andva #$F0
	stskip z set
	goto OFnegExp

/ if +ve exp digit > #$70 then overflow
	movva regC
	movr a Indr
	movr i a
	skipifa >= #$71
	clrb genBits ERflag
	goto testERR

/ if -ve exp digit < #$29 then underflow
OFnegExp,	movva regC
	movr a Indr
	movr i a
	skipifa < #$29
	clrb genBits ERflag

testERR,	skipbs genBits ERflag
	return

	movva D10_ERR
	writod DEV0_OUT a	/ CMD 8X = set display index to X
	reseti 0	/ reset key flag
	return

/ -------------------------------------------
doSQRT,	gosub CintoAW	/ c -> a[w]
	gosub setW	/ sqt11:     b exchange c[w]
	gosub XexchXBC
	goto sqt14

sqt12,	decr regP r	/sqt12:    p - 1 -> p
	gosub setMS	/ a + b -> a[ms]
	gosub AplusBtoA
	skipbs genBits2 bCarry	/ if no carry go to sqt18
	goto sqt18
	goto doError

sqt18,	gosub setX	/ sqt18:   a + b -> a[x]
	gosub AplusBtoA
	skipbs genBits2 bCarry	/ if no carry go to sqt14
	goto sqt14

	gosub setP	/ c - 1 -> c[p]
	gosub CMin1toC
sqt14,	gosub setS	/ sqt14:    c + 1 -> c[s]
	gosub Cplus1toC
	movr regP a	/          if p # 0
	stskip z set
	goto sqt12	/               then go to sqt12

	setb genBits2 regXb
	gosub setX
	gosub XexchX	/ a exchange c[x]
	gosub setX	/ 0 -> a[x]
	gosub ZeroA
	gosub setP	 /if c[p] >= 1
	gosub CmpCto1
	skipbs genBits2 bCarry
	goto sqt13	/ then go to sqt13

	gosub shiftXR	/ shift right a[w]
sqt13,	setb genBits2 regXa	/ shift right c[w]
	setb genBits2 regXb
	gosub shiftXR

	gosub setX	/ b exchange c[x]
	gosub XexchXBC

	gosub setX	/          0 -> c[x]
	gosub ZeroC
	movva #D12	/          12 -> p
	movr a regP
	goto sqt17	/          go to sqt17

sqt15,	gosub setP	/ sqt14:   c + 1 -> c[p]
	gosub Cplus1toC
sqt16,	gosub setW	/ a - c -> a[w]
	gosub AminCtoA
	skipbs genBits2 bCarry
	goto sqt15	/          if no carry go to sqt15

	gosub setW	/          a + c -> a[w]
	gosub AplusCtoA
	gosub shiftALW	/ shift left a[w]

	decr regP r	/         p - 1 -> p
sqt17,	gosub setWP	/ sqt17:    shift right c[wp]
	setb genBits2 regXa
	setb genBits2 regXb
	gosub INshiftR
	movr regP a	/          if p # 0
	stskip z set
	goto sqt16	/               then go to sqt16
	goto tnm12
