/ WIF CLOCK
/ 8 DIGIT DISPLAY USED ON DEV0 OUT
/ KEYPAD2 (IF DESIRED) TO DEV0 IN
/ LOAD CLOCK.KPF FOR A KEY OVERLAY
/ DISPLAY DIGIT INDEXES   0123456789
/                          00:00:00
/ NOTE: THIS CLOCK WILL NOT BE %100 ACCURATE

	_ISWIMODEON

	_RAM

SECS5
SECONDS
MINUTES
HOURS
TEMP
MAX

	_ENDRAM

_CONST	KEYset   #D236	/ Keypad Set Key
_CONST	KEYclr   #D238	/ Keypad Clr Key
_CONST	TIME_5   #D5
_CONST	TIMDEL   #D20	/ 20 X 10 = 200mS timer trigger

START,	GOSUB RSTCLK
	GOSUB NEWDISP

	TIMER TIMDEL	/ set timer delay

KEYWT,	SKIPIF DEV0_IN	/ wait for key press
	GOTO NOKEY

	RDIRST DEV0_IN A	/ key into AC, RESET
	MOVR A TEMP	/ store value

	XORVA KEYset	/ was Set key pressed?
	STSKIP Z CLR
	GOTO SETTIME	/ no

	MOVR TEMP A
	XORVA KEYclr	/ was Clr key pressed?
	STSKIP Z SET
	GOTO NOKEY	/ no

	GOSUB RSTCLK
	GOSUB NEWDISP
	GOTO KEYWT

NOKEY,	TIMER SKIPOF	/ test timer overflowed
	GOTO KEYWT	/ no, look for next keypress

/ -----------------------------------------------
/ TIMER OVERFLOWED, UPDATE COUNTERS
	DECRSZ SECS5 R
	GOTO KEYWT

	MOVVA TIME_5	/ 5 x 200mS per 1 second
	MOVR A SECS5

	INCR SECONDS R	/ seconds + 1
	MOVVA #$0F	/ times are in BCD format
	ANDR SECONDS A T
	XORVA #$0A	/ if units > 9, inc tens
	STSKIP Z SET
	GOTO UPDTDSP

	MOVR SECONDS A
	ANDVA #$F0
	ADDVA #$10
	MOVR A SECONDS

	XORVA #$60	/ if tens > 50 then = 0, inc mins
	STSKIP Z SET
	GOTO UPDTDSP

	CLRR SECONDS R	/ seconds = 0
	INCR MINUTES R	/ minutes + 1
	MOVVA #$0F
	ANDR MINUTES A T
	XORVA #$0A	/ if units > 9, inc tens
	STSKIP Z SET
	GOTO UPDTDSP

	MOVR MINUTES A
	ANDVA #$F0
	ADDVA #$10
	MOVR A MINUTES

	XORVA #$60	/ if tens > 50 then = 0, inc hours
	STSKIP Z SET
	GOTO UPDTDSP

	CLRR MINUTES R
	INCR HOURS R	/ hours + 1
	MOVVA #$24	/ if > 23 then = 0
	XORR HOURS A T
	STSKIP Z SET
	GOTO INCHRS

	CLRR HOURS R
	GOTO UPDTDSP

INCHRS,	MOVR HOURS A
	ANDVA #$0F
	XORVA #$0A	/ if units > 9, inc tens
	STSKIP Z SET
	GOTO UPDTDSP

	MOVR HOURS A
	ANDVA #$F0
	ADDVA #$10
	MOVR A HOURS
UPDTDSP,	GOSUB NEWDISP
	GOTO KEYWT

/ -----------------------------------------------
/ USER WANTS TO SET TIME
SETTIME,	MOVVA D10_BK	/ causes digits to be blank on display
	MOVR A SECONDS
	EXCHR SECONDS
	IORR A SECONDS S
	MOVR A SECONDS
	MOVR A MINUTES
	MOVR A HOURS
	GOSUB NEWDISP

	MOVVA 2	/ max hours 10's = 2
	GOSUB GETKEY
	STSKIP C SET
	GOTO TIMEERR	/ user key > MAX, end entry
	EXCHR TEMP A	/ HOURS 10'S
	IORVA D10_BK
	MOVR A HOURS
	GOSUB NEWDISP

	MOVR TEMP A	/ if hours 10's < 2 then max units = 9
	XORVA 2	/ else MAX UNITS = 3
	MOVVA 9
	STSKIP Z CLR
	MOVVA 3	/ max hours unit's = 3
	GOSUB GETKEY
	STSKIP C SET
	GOTO TIMEERR	/ user key > MAX, end entry
	MOVR HOURS A	/ HOURS unit'S
	ANDVA #$F0
	IORR A TEMP S
	MOVR A HOURS
	GOSUB NEWDISP

	MOVVA 5	/ max minutes 10's = 5
	GOSUB GETKEY
	STSKIP C SET
	GOTO TIMEERR	/ user key > MAX, end entry
	EXCHR TEMP A	/ MINUTES 10'S
	ANDVA #$F0
	IORVA D10_BK
	MOVR A MINUTES
	GOSUB NEWDISP

	MOVVA 9	/ max minutes unit's = 9
	GOSUB GETKEY
	STSKIP C SET
	GOTO TIMEERR	/ user key > MAX, end entry
	MOVR MINUTES A	/ MINUTES unit'S
	ANDVA #$F0
	IORR A TEMP S
	MOVR A MINUTES
	GOSUB NEWDISP

	MOVVA 5	/ max seconds 10's = 5
	GOSUB GETKEY
	STSKIP C SET
	GOTO TIMEERR	/ user key > MAX, end entry
	EXCHR TEMP A	/ SECONDS 10'S
	IORVA D10_BK
	MOVR A SECONDS
	GOSUB NEWDISP

	MOVVA 9	/ max seconds unit's = 9
	GOSUB GETKEY
	STSKIP C SET
	GOTO TIMEERR	/ user key > MAX, end entry
	MOVR SECONDS A	/ SECONDS unit'S
	ANDVA #$F0
	IORR A TEMP S
	MOVR A SECONDS
	GOSUB NEWDISP
	GOTO KEYWT	/ done

TIMEERR,	MOVVA D10_ERR	/ display "Error"
	WRITOD 0 A

	MOVVA #D10	/ display error for 2 secs
	MOVR A TEMP

ERRWT,	TIMER SKIPOF
	GOTO ERRWT

	DECRSZ TEMP R
	GOTO ERRWT

	GOSUB RSTCLK
	GOTO KEYWT	/ done

/ -----------------------------------------------
/ SUBROUTINE: CLEAR CLOCK COUNTERS
RSTCLK,	MOVVA D10_INI
	WRITOD DEV0 A
	MOVVA D10_ON
	WRITOD DEV0 A
	MOVVA TIME_5	/ 5 x 200mS per 1 second
	MOVR A SECS5
	CLRR SECONDS R	/ initialise time counters
	CLRR MINUTES R
	CLRR HOURS R
	RETURN

/ -----------------------------------------------
/ SUBROUTINE: GET A KEYPRESS FROM KEYPAD
GETKEY,	MOVR A MAX
TIMKEY,	SKIPIF DEV0_IN	/ wait for key press - hour tens
	GOTO TIMKEY
	RDIRST DEV0_IN A	/ key into AC, RESET
	MOVR A TEMP	/ store value
	SUBR A MAX S	/ IF KEY > MAX - Carry clear
	RETURN

/ -----------------------------------------------
/ SUBROUTINE: UPDATE A NEW DISPLAY
NEWDISP,	MOVVA D10_IDX
	ADDVA 1
	WRITOD DEV0_OUT A	/ CMD 8X = set display index to X

	EXCHR HOURS A	/ hours to display
	ANDVA #$0F
	WRITOD DEV0_OUT A

	MOVR HOURS A
	ANDVA #$0F
	WRITOD DEV0_OUT A

	MOVVA D10_COL
	WRITOD DEV0_OUT A

	EXCHR MINUTES A	/ minutes to display
	ANDVA #$0F
	WRITOD DEV0_OUT A

	MOVR MINUTES A
	ANDVA #$0F
	WRITOD DEV0_OUT A

	MOVVA D10_COL
	WRITOD DEV0_OUT A

	EXCHR SECONDS A	/ seconds to display
	ANDVA #$0F
	WRITOD DEV0_OUT A

	MOVR SECONDS A
	ANDVA #$0F
	WRITOD DEV0_OUT A
	RETURN
