/ EDUC8 WIF NUMBER HUNT GAME
/ [KEYPAD 2] TO DEV0 INPUT
/ (A keypad file called [NumHunt.kpf] has the game key legends)
/ [8 DIGIT DISPLAY] TO DEV0 OUTPUT
/ OPTIONALLY, THE PRINTER CAN BE CONNECTED TO OUT DEV 1

/
/ GAME DESCRIPTION
/ A SECRET CODE OF 4 DIGITS IS GENERATED.
/ EACH DIGIT IN THE CODE RANGES FROM 0 TO 6
/ TO BREAK THE SECRET CODE, A SERIES OF 4 DIGIT TRIAL CODES ARE KEYED IN.
/ AT EACH TRIAL, 2 TYPES OF FEEDBACK, "C" AND "M" ARE GENERATED.
/ "C" IS THE NUMBER OF COLUMNS WITH MATCHING DIGITS
/ "M" IS THE NUMBER OF MATCHING DIGITS
/ IF 'M" = 4, THEN THE GAME IS WON
/ THE OBJECT OF THE GAME IS TO GUESS THE CORRECT NUMBER IN THE LEAST AMOUNT OF TRIALS
/
/ KEYPAD 2 IS USED TO ENTER THE 4 DIGITS AND EITHER START A "NEW" GAME,
/ "END" A GAME OR START THE CODE TEST PROCEDURE FROM THE "ENT" KEY.
/ THE 8 DIGIT DISPLAY IS USED FOR FEEDBACK
/
/ COMPILE THE CODE, SET THE PC AT "START" = $000, PRESS "RUN"
/ A RANDOM SET OF 4 DIGITS WILL BE CREATED.
/ THE USER THEN KEYS IN 4 DIGITS, THEN PRESSES THE "ENT" KEY
/ THE SOFTWARE WILL CHECK THE USER ENTRY AND REPORT THE RESULT ON THE DISPLAY
/
/ DISPLAY NUMBERING      CHARACTERS
/                        1 2 3 4 5 6 7 8 9 10
/                        B L A N K 0 0 - 0 0    = WAITING FOR USER INPUT
/                                  | |   | |
/        THE 1ST 4 DIGITS WILL     | |   | -  TRIAL COUNT L
/        SHOW THE USER INPUT       | |   - -  TRIAL COUNT H
/        AS IT IS KEYED IN         | - - - -  TRIAL DIGIT COUNT
/                                  - - - - -  TRIAL COLUMN COUNT 
/
/ IF THE MAXIMUM NUMBER OF TRIALS EXPIRES, "ERROR" WILL BE DISPLAYED ALONG WITH
/ THE CORRECT DIGITS
/ IF A WIN OCCURS, THE DISPLAY WILL SHOW THE CORRECT DIGITS AND THE TRIAL COUNT
/ AND IT WILL FLASH 5 TIMES
/
/ TO BEGIN A NEW GAME, PRESS "NEW" ANYTIME
/ TO END A GAME PRESS, "END" ANYTIME
/
/ THE PRINTER CAN HELP KEEP TRACK OF THE TRIAL ENTRIES
/

	_RAM

Indirect	/ storage for Indr
Rnum1	/ Random numbers
Rnum2
Rnum3
Rnum4

Unum1	/ User numbers
Unum2
Unum3
Unum4

Rptr	/ pointers
Rcol
Ucol

Tries	/ counters
CountM
CountC

TempA	/ working registers
TempB
flagReg

disBuff :#D10

	_ENDRAM

_CONST	DIShnum   D10_IDX + #D6
_CONST	Unum41    Unum4 + #D1
_CONST	MAXcount  #$20	/ MAX tries to guess numbers - NUMBER IS BCD FORMAT
		/ EG. FOR 15 TRIES, MAXcount = #$15
		/ absolute MAXcount = 99

	_ISWIMODEON


start,	clrr flagReg
begin,	movva D10_INI
	writod DEV0 A
	gosub DispON
	gosub RandNums	/ setup random numbers to guess
	skipifa neg
	goto newGame

randdone,	halt	/ random number error
	goto begin
/
/ START GAME
/
newGame,	movva Unum1	/ Indr point to user numbers buffer
	movr a Indr
	clrr Tries
	clrr CountM
	clrr CountC
	gosub rstUser	/ reset user data
	gosub updDisp
rstUnum,	clrb flagReg 1
	movva Unum1	/ reset user number pointer
	movr a Rptr
	goto ExKey	/ reset key flag in case key pressed while setting up

/ -----------------------------------------------------------
keywt,	skipif 0	/ wait for key press
	goto keywt

	romptr H HIGH jumpTB	/ set ROM page for [P] [TGT] instructions
	readid 0 a	/ key press into AC
jumpTB,	addr a p t	/ jump table
	goto buttNUM	/ 0
	goto buttNUM	/ 1
	goto buttNUM	/ 2
	goto buttNUM	/ 3
	goto buttNUM	/ 4
	goto buttNUM	/ 5
	goto buttNUM	/ 6
	goto buttNUM	/ 7
	goto buttNUM	/ 8
	goto buttNUM	/ 9
	goto buttNEW	/ New game
	goto buttENT	/ check user input
	goto buttEND	/ user gave up

/ -----------------------------------------------------------
/ ENTER NEXT NUMBER
buttNUM,	movr a TempA	/ temp save key
	skipbs flagReg 1	/ reset user display if [1] = 0
	gosub rstUser	/ reset user data

	setb flagReg 1
	movva Unum41
	xorr a Rptr s
	stskip z clr
	goto ExKey	/ all numbers entered, waiting for 'ENT' next

	movr Rptr a
	movr a Indr
	movr TempA a	/ store next key press
	movr a i
	incr Rptr	/ tab next key
	gosub updDisp	/ update the display

ExKey,	reseti 0	/ reset key flag
	goto keywt

/ -----------------------------------------------------------
/ USER GAVE UP
buttEND,	gosub FailDisp
	gosub prnError
rstky,	reseti 0	/ reset key flag

keywt2,	skipif 0	/ wait for key press
	goto keywt2

	readid 0 a	/ key press into AC
	xorva #D10	/ is it "New" key
	stskip z set
	goto rstky	/ no
/
/ START NEW GAME
/
buttNEW,	reseti 0	/ reset key flag
	goto begin	/ new game

/ -----------------------------------------------------------
/ TEST USER INPUT AND REPORT RESULTS
buttENT,	movva Unum41	/ all 4 user digits entered?
	xorr a Rptr s
	stskip z set
	goto ExKey	/ no

	movva Rnum1
	movr a Rptr
	clrr Rcol
	clrr CountM
	clrr CountC

Rloop,	movr Rptr a	/ random digit to test
	movr a Indr
	movr i TempA

	movva Unum1	/ test against all user digits
	movr a Indr
	clrr Ucol

Uloop,	movr TempA a
	xorr a i s
	stskip z set
	goto noMatch

	incr CountM	/ increase number of matching digits

	movr Ucol a
	xorr a Rcol s
	stskip z clr
	incr CountC	/ number matches in column
	
	movva #$FF	/ mask out digit so it fails test in next iteration
	movr a i
	goto nxtRdgt	/ next random digit

noMatch,	movva Unum4	/ tested all user digits?
	xorr a Indr s
	stskip z clr
	goto nxtRdgt	/ yes

	incr Indr
	incr Ucol
	goto Uloop	/ not yet

nxtRdgt,	movva Rnum4	/ tested all random digits
	xorr a Rptr s
	stskip z clr
	goto maxCnt	/ yes

	incr Rptr
	incr Rcol
	goto Rloop	/ next random digit

/ -----------------------------------------------------------
/ no match - if MAX Tries reached then end of game
maxCnt,	movva 1	/ add 1 to tries
	addr a Tries s
	daac	/ keep in BCD format
	movr a Tries

	movr CountC a	/ 4 matching digits = a win
	xorva 4
	stskip z clr
	goto win

	movva MAXcount	/ if max tried reached, game failed
	xorr a Tries s
	stskip z clr
	goto buttEND

	gosub updCount	/ update counters in disp buffer
	gosub prnUser	/ for printing
	reseti 0	/ reset key flag
	goto rstUnum	/ clear user numbers, and get next user input

win,	gosub WinDisp	/ show winner display
	gosub prnUser
	gosub dispFlash
	goto rstky	/ "New" button starts again
/
/ -------------------------------------
/ SUBROUTINE: SETUP GAME RANDOM NUMBERS
/ -------------------------------------
/ AC = negative on return if error, else positive
/
RandNums,	movva Rnum1
	movr a Indr
rnloop1,	clrr TempA
	clrr TempB
rnloop2,	randa
rnloop3,	decrsz TempB
	goto rnloop2

	andva #$0F
	skipifa < 7
	goto renew

	movr a i
	movva Rnum4
	xorr a Indr s
	stskip z clr
	return	/ no error on return, AC bit 7 = 0

	incr Indr
	goto rnloop1

renew,	decrsz TempA
	goto rnloop2

	/ could not resolve random numbers this time, display "error"
	/ user can restart by pressing "RUN' again

	movva D10_ERR
	writod DEV0_OUT a
	movva #$FF	/ error on return, AC bit 7 = 1
	return
/
/ ---------------------------
/ SUBROUTINE: TURN DISPLAY ON
/ ---------------------------
/
DispON,	movva D10_ON
	goto DispSet
/
/ ----------------------------
/ SUBROUTINE: TURN DISPLAY OFF
/ ----------------------------
/
DispOFF,	movva D10_OFF
DispSet,	WRITOD DEV0 A
	return
/
/ ---------------------------------------
/ SUBROUTINE: RESET USER NUMBERS TO BLANK
/ ---------------------------------------
/
rstUser,	movva D10_BK
	movr a Unum1
	movr a Unum2
	movr a Unum3
	movr a Unum4
	return
/
/ -------------------------------
/ SUBROUTINE: INCREMENT TRY Tries
/ -------------------------------
/
IncCount,	movr Tries a	/ Tries is BCD format
	addva 1
	daac
	movr a Tries
	return
/
/ --------------------------
/ SUBROUTINE: UPDATE DISPLAY
/ --------------------------
/
updCount,	movva disBuff	/ init buffer pointer
	addva 5
	movr a Indr
	goto updCnt

updDisp,	movva disBuff	/ init buffer pointer
	movr a Indr
	movr Unum1 a	/ enter all user digits
	movr a i
	incr Indr
	movr Unum2 a
	movr a i
	incr Indr
	movr Unum3 a
	movr a i
	incr Indr
	movr Unum4 a
	movr a i
	incr Indr

	xorva D10_BK
	movva D10_NEG	/ spacer
	stskip z clr
	movva D10_BK	/ blank if user data blank
	movr a i
	incr Indr

updCnt,	movr CountM a	/ enter Number match
	movr a i
	incr Indr
	movr CountC a	/ enter Column match
	movr a i
	incr Indr


	movva D10_NEG	/ spacer
	movr a i
	incr Indr

dispHL,	exchr Tries a	/ enter tries H
	andva #$0F
	movr a i
	incr Indr
	movr Tries a	/ enter tries L
	andva #$0F
	movr a i

	gosub DispOut
	return
/
/ -------------------------------
/ SUBROUTINE: DISPLAY WIN DISPLAY
/ -------------------------------
/
WinDisp,	movva disBuff	/ init buffer pointer
	movr a Indr

	movr Rnum1 a	/ enter all user digits
	movr a i
	incr Indr
	movr Rnum2 a
	movr a i
	incr Indr
	movr Rnum3 a
	movr a i
	incr Indr
	movr Rnum4 a
	movr a i
	incr Indr

	movva D10_NEG	/ spacer
	movr a i
	incr Indr
	movva D10_NEG	/ spacer
	movr a i
	incr Indr
	movva D10_NEG	/ spacer
	movr a i
	incr Indr
	movva D10_NEG	/ spacer
	movr a i
	incr Indr

	goto dispHL
	return
/
/ -------------------------------------
/ SUBROUTINE: DISPLAY USER QUIT DISPLAY
/ -------------------------------------
/
FailDisp,	movva D10_ERR	/ output "Error"
	writod DEV0_OUT a

hnumDisp,	movva DIShnum
	writod DEV0_OUT a	/ display buffer index to last 4 digits
	
	movr Rnum1 a	/ enter all user digits
	writod DEV0_OUT a
	movr Rnum2 a
	writod DEV0_OUT a
	movr Rnum3 a
	writod DEV0_OUT a
	movr Rnum4 a
	writod DEV0_OUT a
	gosub dispFlash
	return
/
/ --------------------------------
/ SUBROUTINE: CLEAR DISPLAY BUFFER
/ --------------------------------
/
ClrDbuff,	movva disBuff
	movr a Indr
	movva #D10
	movr a TempA
	movva D10_BK
CDBlp,	movr a i
	incr Indr
	decrsz TempA
	goto CDBlp
	return
/
/ --------------------------------
/ SUBROUTINE: OUTPUT DISPLY BUFFER
/ --------------------------------
/
DispOut,	movva disBuff
	movr a Indr
	movva #D10
	movr a TempA

	movva D10_IDX
	writod DEV0_OUT a	/ CMD 40 = set display index to 0

DOloop,	movr i a
	writod DEV0_OUT a
	incr Indr
	decrsz TempA
	goto DOloop
	return
/
/ ---------------------------
/ SUBROUTINE: PRINT USER DATA
/ ---------------------------
/
prnUser,	movva disBuff
	movr a Indr
	movva #D10
	movr a TempA
prnLoop,	movr i a
	gosub prnXlate
	gosub PRNout

	incr Indr
	decrsz TempA
	goto prnLoop
	return
/
/ -------------------------------
/ SUBROUTINE: PRINT ERROR MESSAGE
/ -------------------------------
/
prnError,	clrr TempA
prnELoop,	movr TempA a
	gosub prnERR
	gosub PRNout

	incr TempA
	movva 6
	xorr a TempA s
	stskip z set
	goto prnELoop

	movr Rnum1 a	/ enter all user digits
	gosub prnXlate
	gosub PRNout
	movr Rnum2 a
	gosub prnXlate
	gosub PRNout
	movr Rnum3 a
	gosub prnXlate
	gosub PRNout
	movr Rnum4 a
	gosub prnXlate
	gosub PRNout
	return
/
/ -------------------------------
/ SUBROUTINE: OUTPUT PRINTER CHAR
/ -------------------------------
/
PRNout,	skipbc flagReg 0
	return	/ printer not connected

	timer #D50
	wtorst 1 A
prnWait,	skipof 1	/ wait for printer to be ready after a char is printed
	goto timertst	/ wait for 1/2 secod, if no response, printer offline
	return

timertst,	timer skipof
	goto prnWait

	setb flagReg 0	/ timeout - printer not connected
	return
/
/ -------------------------
/ SUBROUTINE: FLASH DISPLAY
/ -------------------------
/
dispFlash,	timer #D20
	movva 5
	movr a TempB
flLoop1,	timer skipof
	goto flloop1
	gosub dispOFF

flLoop2,	timer skipof
	goto flLoop2

	gosub DispON
	decrsz TempB
	goto flLoop1
	return
/
/ DATA TABLE #1
/
prnXlate,	romptr H HIGH prnTB	/ set ROM page for [P] [TGT] instructions
prnTB,	addr a p t	/ jump table
	_STRING "0123456789-:. "
/
/ DATA TABLE #2
/
prnERR,	romptr H HIGH prnER	/ set ROM page for [P] [TGT] instructions
prnER,	addr a p t	/ jump table
	_STRING "Error "	/ Error for printer display
