/ EDUC-8 WIF TIC TAC TOE GAME
/ PRINTER TO DEV 0 OUT
/ KEYPAD2 TO DEV 0 IN
/ COMPILE CODE AND RUN FROM START (ADDRESS 0)
/ (A keypad file called [tictactoe.kpf] has the game key legends)
/
/ THE PLAYER USES CROSSES, THE EDUC-8 USES NOUGHTS
/ THE PLAYER HAS THE FIRST MOVE
/ TO PLAY A MOVE, PRESS ANY BUTTON FROM 1 - 9
/ THESE BUTTON MATCH THE DIAGRAM BELOW
/
/   1 | 2 | 3 
/   ---------
/   4 | 5 | 6 
/   ---------
/   7 | 8 | 9 
/
/ WHEN A CROSS IS PLACED INTO A SQUARE, THE EDUC-8 WILL TAKE
/ A SECOND TO PONDER A NEW MOVE TO TRY AND WIN.
/ WHEN THE NOUGHT HAS BEEN ENTERED A DIAGRAM OF THE GAME STATE
/ WILL APPEAR ON THE PRINTER
/ BLANK SQUARES WILL HAVE AN UNDERSCORE CHARACTER (_)
/
/ TO BEGIN A NEW GAME AT ANYTIME, PRESS [New]
/

	_RAM

Indirect
playGrid1
playGrid2
playGrid3
playGrid4
playGrid5
playGrid6
playGrid7
playGrid8
playGrid9
TempA
TempB
flagReg
gTest1
gTest2
gTest3
randVal
	_ENDRAM

	_ISWIMODEON

_CONST	gBlank      0
_CONST	gCross      1
_CONST	gCross2     2	/ 2 times gCross value
_CONST	gCross3     3	/ 3 times gCross value
_CONST	gNought     #D10
_CONST	gNought2    #D20	/ 2 times gNought value
_CONST	fillLine #P" " + #D128	/ causes printer to fill rest of line with spaces
_CONST	fgTest      0
_CONST	fgFirst     1
_CONST	fgGameOver  2
_CONST	gameSqrs    9	/ 9 game sqaures

/ -------------------------------------
start,	clrr flagReg
	gosub newGrid
	movva msgGame	/ print "new game"
	gosub printMsg
	goto keyrst	/ in case player got anxious and pressed a key too early

/ -------------------------------------
keywt,	skipif 0	/ wait for key press
	goto keywt

	readid 0 a	/ key press into AC
	movr a TempA
	xorva 9
	stskip z clr
	goto NewButt	/ New button pressed

	skipbc flagReg fgGameOver
	goto keyrst	/ game already finished

	movr TempA a	/ number pressed
	addva playGrid1
	movr a Indr	/ get matching grid register

	movr i a	/ if it is blank, then add a cross
	xorva gBlank
	stskip z set
	goto keyrst	/ square not blank, ignore keypress

/ -------------------------------------
	movva gCross	/ store cross in chosen square
	movr a i

	gosub think

	gosub userWin
	skipbc flagReg fgTest
	goto gameUser

	gosub drawTest	/ test for a draw (all squares now full)
	skipbc flagReg fgTest
	goto gameDraw

/ -------------------------------------
	gosub getRand
	skipbc flagReg fgFirst
	goto notFirst

/ -------------------------------------
	setb flagReg fgFirst	/ computers first move
	movr playGrid5 a
	stskip z clr
	goto PCusemid

	clrr TempA	/ player used centre square already
rcnrLoop,	movr randVal a	/ pick a random grid corner to place a nought
	stskip z clr
	goto setCrnr	/ random number expired, set corner

	incr TempA
	decr randVal
	goto rcnrLoop

setCrnr,	gosub getCrnr	/ get corner value
	addva LOW playGrid1	/ store in corner register
	movr a Indr
	movva gNought
	movr a i
	goto updtGrid

PCusemid,	movva gNought	/ put nought in centre square
	movr a playGrid5
	goto updtGrid

/ -------------------------------------
notFirst,	gosub educWin	/ see if EDUC-8 won
	skipbc flagReg fgTest
	goto gameEduc

/ -------------------------------------
	gosub blokMove	/ try to block player from winning on next move
	skipbc flagReg fgTest
	goto updtGrid

/ -------------------------------------
	gosub educMove	/ try to add another nought inline with a single one
	skipbc flagReg fgTest
	goto updtGrid

/ -------------------------------------
	gosub randMove	/ random move
updtGrid,	gosub prnGrid	/ print new move
keyrst,	reseti 0	/ reset key flag
	goto keywt

/ -------------------------------------
NewButt,	reseti 0	/ start again
	goto start

/ -------------------------------------
gameDraw,	gosub prnGrid	/ print grid
	movva msgDraw	/ print "drawn game"
	gosub printMsg
	setb flagReg fgGameOver
	goto prnMore

gameUser,	gosub prnGrid	/ print grid
	movva msgPwin	/ print "player won"
	gosub printMsg
	setb flagReg fgGameOver
	goto prnMore

gameEduc,	gosub prnGrid	/ print grid
	movva msgEwin	/ print "computer won"
	gosub printMsg
	setb flagReg fgGameOver

prnMore,	movva msgMore	/ let player know that "New" starts again
	gosub printMsg
	goto keyrst
/
/ -----------------------------
/ SUBROUTINE: SET NEW PLAY GRID
/ -----------------------------
/
newGrid,	movva playGrid1
	movr a Indr
	movva gameSqrs
	movr a TempA
	movva gBlank
nwgrLoop,	movr a i
	incr Indr
	decrsz TempA
	goto nwgrLoop
	return
/
/ -------------------------------
/ SUBROUTINE: PRINT THE GAME GRID
/ -------------------------------
/
prnGrid,	movva #P" "	/ leading space
	gosub prnChar
	movr playGrid1 a	/ top left square
	gosub gridChar
	gosub prnChar
	movva #P" "
	gosub prnChar
	movr playGrid2 a	/ top centre square
	gosub gridChar
	gosub prnChar
	movva #P" "
	gosub prnChar
	movr playGrid3 a	/ top right square
	gosub gridChar
	gosub prnChar
	movva fillLine	/ fill rest of line with blanks
	gosub prnChar

	movva #P" "
	gosub prnChar
	movr playGrid4 a	/ middle left square
	gosub gridChar
	gosub prnChar
	movva #P" "
	gosub prnChar
	movr playGrid5 a	/ middle centre square
	gosub gridChar
	gosub prnChar
	movva #P" "
	gosub prnChar
	movr playGrid6 a	/ middlw right square
	gosub gridChar
	gosub prnChar
	movva fillLine	/ fill rest of line with blanks
	gosub prnChar

	movva #P" "
	gosub prnChar
	movr playGrid7 a	/ bottom left square
	gosub gridChar
	gosub prnChar
	movva #P" "
	gosub prnChar
	movr playGrid8 a	/ bottom centre square
	gosub gridChar
	gosub prnChar
	movva #P" "
	gosub prnChar
	movr playGrid9 a	/ bottom right square
	gosub gridChar
	gosub prnChar
	movva fillLine	/ fill rest of line with blanks
	gosub prnChar

	movva fillLine	/ line feed
	gosub prnChar
/	movva fillLine	/ line feed
/	gosub prnChar
	return
/
/ -------------------------------
/ SUBROUTINE: RETURN CORNER VALUE
/ -------------------------------
/
getCrnr,	romptr H HIGH getCrnr	/ set ROM page for [P] [TGT] instructions
	movr TempA a
	andva 3	/ in case > 3
	addr a p t
	retval 0	/ TL corner
	retval 2	/ TR corner
	retval 6	/ BL corner
	retval 8	/ BR corner
/
/ -----------------------------------------------------
/ SUBROUTINE: CONVERT REGISTER GRID VALUE TO PRINT CHAR
/ -----------------------------------------------------
/
gridChar,	movr a TempA
	xorva gCross
	stskip z clr
	retval #P"X"

	movr TempA a
	xorva gNought
	stskip z clr
	retval #P"O"
	retval #P"_"
/
/ -------------------------
/ GAME MESSAGES FOR PRINTER
/ -------------------------
/
printMsg,	subva LOW msgGame	/ adjust msg offset
	movr a TempA
	romptr H HIGH getChar	/ set ROM page for [P] [TGT] instructions	
pmsgLoop,	gosub getChar
	skipifa >= 1
	goto extLine

	gosub prnChar
	incr TempA
	goto pmsgLoop

extLine,	movva fillLine	/ fill rest of line with spaces
	gosub prnChar
	movva fillLine	/ line feed
	gosub prnChar
	return

getChar,	ADDR TempA P T
msgGame,	_PSTRING "<NEW GAME>@"	/ zero terminated strings
msgDraw,	_PSTRING "DRAWN GAME@"
msgPwin,	_PSTRING "PLAYER WINS YAY!!@"
msgEwin,	_PSTRING "EDUC-8 WINS :-)@"
msgMore,	_PSTRING "MORE?  PRESS NEW@"
/
/ -------------------------------------
/ SUBROUTINE: OUTPUT AC CHAR TO PRINTER
/ -------------------------------------
/
prnChar,	wtorst 0 a
prnWait,	skipof 0
	goto prnWait
	return
/
/ -----------------------------------
/ SUBROUTINE: TEST IF PLAYER WON GAME
/ -----------------------------------
/
userWin,	clrb flagReg fgTest	/ player did not win
	gosub set012
	gosub didPwin
	skipbc flagReg fgTest
	return
	
	gosub set345
	gosub didPwin
	skipbc flagReg fgTest
	return	

	gosub set678
	gosub didPwin
	skipbc flagReg fgTest
	return	

	gosub set036
	gosub didPwin
	skipbc flagReg fgTest
	return	

	gosub set147
	gosub didPwin
	skipbc flagReg fgTest
	return	

	gosub set258
	gosub didPwin
	skipbc flagReg fgTest
	return	

	gosub set048
	gosub didPwin
	skipbc flagReg fgTest
	return	

	gosub set246
	gosub didPwin
	return
/
/ -----------------------------------
/ SUBROUTINE: TEST IF EDUC-8 WON GAME
/ -----------------------------------
/
educWin,	clrb flagReg fgTest	/ EDUC-8 did not win
	gosub set012
	gosub didEwin
	skipbc flagReg fgTest
	return
	
	gosub set345
	gosub didEwin
	skipbc flagReg fgTest
	return	

	gosub set678
	gosub didEwin
	skipbc flagReg fgTest
	return	

	gosub set036
	gosub didEwin
	skipbc flagReg fgTest
	return	

	gosub set147
	gosub didEwin
	skipbc flagReg fgTest
	return	

	gosub set258
	gosub didEwin
	skipbc flagReg fgTest
	return	

	gosub set048
	gosub didEwin
	skipbc flagReg fgTest
	return	

	gosub set246
	gosub didEwin
	return
/
/ ------------------------------------------------------
/ SUBROUTINE: TRY TO BLOCK PLAYER FROM WINNING NEXT MOVE
/ ------------------------------------------------------
/
blokMove,	clrb flagReg fgTest	/ EDUC-8 did not block move
	gosub set012
	gosub didBlok
	skipbc flagReg fgTest
	return
	
	gosub set345
	gosub didBlok
	skipbc flagReg fgTest
	return	

	gosub set678
	gosub didBlok
	skipbc flagReg fgTest
	return	

	gosub set036
	gosub didBlok
	skipbc flagReg fgTest
	return	

	gosub set147
	gosub didBlok
	skipbc flagReg fgTest
	return	

	gosub set258
	gosub didBlok
	skipbc flagReg fgTest
	return	

	gosub set048
	gosub didBlok
	skipbc flagReg fgTest
	return	

	gosub set246
	gosub didBlok
	return
/
/ --------------------------------------------------------
/ SUBROUTINE: EDUC-8 TRY TO ADD ANOTHER NOUGHT IN SAME ROW
/ --------------------------------------------------------
/
educMove,	clrb flagReg fgTest	/ EDUC-8 did not block move
	gosub set012
	gosub didMove
	skipbc flagReg fgTest
	return
	
	gosub set345
	gosub didMove
	skipbc flagReg fgTest
	return	

	gosub set678
	gosub didMove
	skipbc flagReg fgTest
	return	

	gosub set036
	gosub didMove
	skipbc flagReg fgTest
	return	

	gosub set147
	gosub didMove
	skipbc flagReg fgTest
	return	

	gosub set258
	gosub didMove
	skipbc flagReg fgTest
	return	

	gosub set048
	gosub didMove
	skipbc flagReg fgTest
	return	

	gosub set246
	gosub didMove
	return
/
/ -----------------------------------
/ SUBROUTINE: TEST IF PLAYER WON GAME
/ -----------------------------------
/
didPwin,	clrr TempA	/ get 3 square indexes to look up RAM addresses
	movr gTest1 a	/ add all register values
	addva playGrid1	/ if = 3 crosses, then game won by player
	movr a Indr
	movr i a
	addr a TempA t

	movr gTest2 a
	addva playGrid1
	movr a Indr
	movr i a
	addr a TempA t

	movr gTest3 a
	addva playGrid1
	movr a Indr
	movr i a
	addr a TempA s

	skipifa = gCross3
	return

	setb flagReg fgTest	/ player did win
	return
/
/ ---------------------------------------------------
/ SUBROUTINE: TRY TO BLOCK PLAYER FROM COMPLETING WIN
/ ---------------------------------------------------
/
didBlok,	movva gCross2	/ test for 2 crosses
	goto inEwin	/ same subroutine as didEwin
/
/ ------------------------------------------------------------
/ SUBROUTINE: TRY TO ADD A NOUGHT IN LINE WITH A SINGLE NOUGHT
/ ------------------------------------------------------------
/
didMove,	movva gNought
	goto inEwin
/
/ -------------------------------------------------------------
/ SUBROUTINE: TEST IF EDUC-8 WON GAME or BLOCK MOVE or NEW MOVE
/ -------------------------------------------------------------
/
didEwin,	movva gNought2	/ test for 2 noughts
inEwin,	movr a TempB
	clrr TempA	/ get 3 square indexes to look up RAM addresses
	movr gTest1 a	/ add all register values
	addva playGrid1	/ see if = 2 noughts, then test for next is a blank
	movr a Indr
	movr i a
	addr a TempA t

	movr gTest2 a
	addva playGrid1
	movr a Indr
	movr i a
	addr a TempA t

	movr gTest3 a
	addva playGrid1
	movr a Indr
	movr i a
	addr a TempA s
	xorr a TempB s
	stskip z set
	return	/ comparison not found

	movr gTest1 a	/ if test register 1 = blank then is a nought
	addva playGrid1
	movr a Indr
	movr i a
	xorva gBlank
	stskip z clr
	goto educWins

	movr gTest2 a	/ if test register 2 = blank then is a nought
	addva playGrid1
	movr a Indr
	movr i a
	xorva gBlank
	stskip z clr
	goto educWins
	
	movr gTest3 a	/ register 3 = blank so is a nought
	addva playGrid1
	movr a Indr

educWins,	movva gNought	/ EDUC-8's winning/blocking/move nought
	movr a i
	setb flagReg fgTest
	return
/
/ ------------------------------
/ SUBROUTINE: EDUC-8 RANDOM MOVE
/ ------------------------------
/
randMove,	clrr TempA	/ square index 
	clrr TempB	/ random match counter
rmLoop,	movva playGrid1
	addr a TempA s
	movr a Indr
	movr i a
	xorva gBlank
	stskip z set
	goto ntBlank

	movr randVal a	/ does random counter match random value?
	xorr a TempB s
	stskip z clr
	goto gotRM	/ yes, got square

	incr TempB	/ increment random match
ntBlank,	incr TempA	/ next square
	movva gameSqrs
	xorr a TempA s
	stskip z clr
	clrr TempA	/ back to squares start
	goto rmLoop

gotRM,	movva gNought	/ place nought in available square
	movr a i
	return
/	
/ -----------------------------------------
/ SUBROUTINES: SET GRIS CHECKING REFERENCES
/ -----------------------------------------
/
set012,	movva 0
	movr a gTest1
	movva 1
	movr a gTest2
	movva 2
	movr a gTest3
	return

set345,	movva 3
	movr a gTest1
	movva 4
	movr a gTest2
	movva 5
	movr a gTest3
	return

set678,	movva 6
	movr a gTest1
	movva 7
	movr a gTest2
	movva 8
	movr a gTest3
	return

set036,	movva 0
	movr a gTest1
	movva 3
	movr a gTest2
	movva 6
	movr a gTest3
	return

set147,	movva 1
	movr a gTest1
	movva 4
	movr a gTest2
	movva 7
	movr a gTest3
	return

set258,	movva 2
	movr a gTest1
	movva 5
	movr a gTest2
	movva 8
	movr a gTest3
	return

set048,	movva 0
	movr a gTest1
	movva 4
	movr a gTest2
	movva 8
	movr a gTest3
	return

set246,	movva 2
	movr a gTest1
	movva 4
	movr a gTest2
	movva 6
	movr a gTest3
	return
/
/ ----------------------------------
/ SUBROUTINE: TEST IF GAME IS A DRAW
/ ----------------------------------
/
drawTest,	clrb flagReg fgTest	/ game is not a draw
	movva playGrid1
	movr a Indr
	movva gameSqrs
	movr a TempA
drawLoop,	movr i a
	xorva gBlank
	stskip z clr
	return	/ still a blank square, not a draw

	incr Indr
	decrsz TempA
	goto drawLoop

	setb flagReg fgTest	/ game is a draw
	return
/
/ ------------------------------
/ SUBROUTINE: GET A RANDOM VALUE
/ ------------------------------
/
getRand,	randa	/ get a random number
	andva #$7F	/ limit size 0 - 127
	movr a randVal
	return
/
/ -----------------------------
/ SUBROUTINE: EDUC-8 THINK TANK
/ -----------------------------
/
think,	timer #D150	/ while away 1.5 seconds for EDUC-8 to "ponder its move"
thWait1,	movr TempA a
	multa #$23
	multa LA
	movr a TempA
	timer skipof
	goto thWait1
	return

